#!/bin/sh

mkdir -p /var/log/NatACL >/dev/null 2>/dev/null
mkdir -p /var/NatACL/html >/dev/null 2>/dev/null


if test -f "/var/dhcp.db"; then
    echo
    echo '**** WARNING ***** You have a old database format- New DB will be created *'
    echo '* You will have to re-configure your NatACL *'
    echo '*                                                                  *'
    echo '* When a final version is release, a conversion tool will automaticly update databases from others version'
    echo 
fi

if test -f "/var/NatACL/NatACL.v1.db"; then
    echo Keeping original /var/NatACL/NatACL.v1.db
else
    echo Creating sqlite /var/NatACL/NatACL.v1.db
    cat sqlite.schema | sqlite3 /var/NatACL/NatACL.v1.db
fi

if test -f "/var/NatACL/html/main.html"; then
    echo Keeping original main.html
else
    cp main.html /var/NatACL/html/main.html

fi
if test -f "/var/NatACL/html/login.html"; then
    echo Keeping original login.html
else
    cp main.html /var/NatACL/html/login.html

fi
if test -f "/var/NatACL/cert_server.pem"; then
    echo Keeping original cert_server.pem
else
	echo
	echo	
	echo

        openssl req -new -x509 -out /var/NatACL/cert_server.pem -nodes -days 366 -keyout /var/NatACL/cert_server.pem
fi


