#include <sqlite3.h>

#include<stdio.h>
#include <stdlib.h>
#include <string.h>



#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#include <sys/socket.h>
#include <sys/errno.h>

#include <time.h>

#include "../common/conversion.h"
#include "db.h"



int select_address_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->bu_group_id = atol(p_fields[0]);
    s_db->client_address = atol(p_fields[1]);
    snprintf(s_db->name, 128, "%s", p_fields[2]);

    return 0;
}
int select_natacl_group_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->natacl = atol(p_fields[0]);

    s_db->s_natacl.id = atol(p_fields[0]);
    s_db->s_natacl.group_id = atol(p_fields[1]);
    snprintf(s_db->s_natacl.config, 128, "%s", p_fields[2]);

    return 0;
}
int select_address_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct in_addr in;
    struct s_db_hdr s_db;
    unsigned char *mac;
    long long l_mac;

    l_mac = atoll(p_fields[0]);

    s_db.bu_group_id = atol(p_fields[1]);
    s_db.client_address = atol(p_fields[2]);
    snprintf(s_db.name, 128, "%s", p_fields[3]);

    in.s_addr = htonl(s_db.client_address);

    mac = (unsigned char *) &l_mac;
//    static char *getname( unsigned long address )

    printf("%02x:%02x:%02x:%02x:%02x:%02x %02d %20s %30s %35s  0x%02x%02x%02x%02x%02x%02x\n", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5], s_db.bu_group_id, inet_ntoa(in), s_db.name, getname(in.s_addr), mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
    fflush(stdout);


    return 0;
}

int select_group_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct in_addr in;
    struct s_db_hdr s_db;
//    unsigned char *mac;
//    long long l_mac;

//    l_mac = atoll(p_fields[0]);

    s_db.bu_group_id = atol(p_fields[0]);
    snprintf(s_db.name, 128, "%s", p_fields[1]);
    s_db.router_address = atol(p_fields[2]);
    s_db.broadcast_address = atol(p_fields[3]);
    s_db.dns_address = atol(p_fields[4]);
    s_db.wins_address = atol(p_fields[5]);

    in.s_addr = htonl(s_db.client_address);

    printf("%02d [%15s]", s_db.bu_group_id, s_db.name );
    in.s_addr = htonl(s_db.router_address);
    printf(" ROUTER: %20s", inet_ntoa(in));
    in.s_addr = htonl(s_db.broadcast_address);
    printf(" BROADCAST: %20s", inet_ntoa(in));
    in.s_addr = htonl(s_db.dns_address);
    printf(" DNS: %20s", inet_ntoa(in));
    in.s_addr = htonl(s_db.wins_address);
    printf(" WINS: %20s", inet_ntoa(in));
    printf("\n");
    fflush(stdout);


    return 0;
}

int select_policy_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    printf("%2s %20s TYPE: %10s CONFIG: %15s ADDRESS: %15s PORT: %s\n",p_fields[0],p_fields[1],p_fields[2],p_fields[3],p_fields[4],p_fields[5] );
    
    return 0;
}
int select_client_policy_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    printf("%20s TYPE: %10s CONFIG: %15s ADDRESS: %15s PORT: %s\n",p_fields[0],p_fields[1],p_fields[2],p_fields[3],p_fields[4] );


    
    return 0;
}








int select_sourcenat_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    snprintf(s_db->source_ip, 20, "%s", p_fields[0]);

    s_db->snat = 1;
    return 0;
}
int select_destinationnat_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    snprintf(s_db->destination_ip, 20, "%s", p_fields[0]);
    s_db->destination_port = atol(p_fields[1]);

    s_db->dnat = 1;

    return 0;
}


int select_groupid_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;


    snprintf(s_db->group_name, 64, "%s", p_fields[0]);
    s_db->router_address = atol(p_fields[1]);
    s_db->broadcast_address = atol(p_fields[2]);
    s_db->dns_address = atol(p_fields[3]);
    snprintf(s_db->domain, 64, "%s", p_fields[4]);
    s_db->wins_address = atol(p_fields[5]);

    return 0;
}
int select_last_ip_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->last_address = atol(p_fields[0]);

    return 0;
}
int select_groupid2_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;


    s_db->bu_group_id = atol(p_fields[0]);
    s_db->router_address = atol(p_fields[1]);
    s_db->broadcast_address = atol(p_fields[2]);
    s_db->dns_address = atol(p_fields[3]);
    snprintf(s_db->domain, 64, "%s", p_fields[4]);
    s_db->wins_address = atol(p_fields[5]);

    return 0;
}


int db_insert_client(struct s_db_hdr *s_db, long long address)
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;


    printf("ADDING MAC: %lld\n", address);
    fflush(stdout);

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into address ( mac_address, client_address, last_tv, bu_group_id, name ) values (  %lld,%ld,%ld,%d,'%s' )", address, s_db->client_address, time(NULL), s_db->bu_group_id, s_db->name);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
    return 1;
}
//int db_insert_group(char *name, char *router_address, char *broadcast_address, char *dns_address, char *wins_address, char *domain)
int db_insert_group(char *name, uint32_t router_address, uint32_t broadcast_address, char * dns_address, char *wins_address, char *domain)
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into bu_group ( name, router_address, broadcast_address, dns_address, domain, wins_address ) values (  '%s',%u,%u,%u,'%s',%u )", name, ntohl(router_address), ntohl(broadcast_address),
             ntohl(inet_addr(dns_address)), domain, ntohl(inet_addr(wins_address)));

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
    return 1;
}

int db_insert_group_policy(int groupid, char * type, char * config, char * address, int port  )
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into group_policy ( bu_group_id, type, config, address, port ) values (%d,'%s','%s','%s',%d) ", groupid, type, config, address, port );

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
    return 1;
}



int db_insert_client_policy(unsigned long long mac_address, char * type, char * config, char * address, int port  )
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into client_policy ( mac_address, type, config, address, port ) values (%lld,'%s','%s','%s',%d) ", mac_address, type, config, address, port );

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
    return 1;
}




















int db_insert_snat(long long address, char *ip)
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into firewall_snat (  mac_address, source_ip  ) values ( %lld, '%s' )", address, ip);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
    return 1;
}
int db_insert_dnat(long long address, char *ip, int port)
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into firewall_dnat (  mac_address, destination_ip, destination_port  ) values ( %lld, '%s', %d )", address, ip, port);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
    return 1;
}
int db_search_mac(struct s_db_hdr *s_db, unsigned char *address)
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];
    long long *int_address = (long long *) address;

    memset(s_db, 0x00, sizeof(struct s_db_hdr));

    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select bu_group_id, client_address, name from address where mac_address=%lld", *int_address);


    rc = sqlite3_exec(db, query, select_address_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        sqlite3_close(db);

        return 0;
    }

    snprintf(query, 255, "select name, router_address, broadcast_address, dns_address, domain, wins_address from bu_group where id=%d", s_db->bu_group_id);

    rc = sqlite3_exec(db, query, select_groupid_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        sqlite3_close(db);
        return 0;
    }


    snprintf(query, 255, "select source_ip from firewall_snat where mac_address=%lld", *int_address);

    rc = sqlite3_exec(db, query, select_sourcenat_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        sqlite3_close(db);
        return 0;
    }

    snprintf(query, 255, "select destination_ip, destination_port from firewall_dnat where mac_address=%lld", *int_address);

    rc = sqlite3_exec(db, query, select_destinationnat_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        sqlite3_close(db);
        return 0;
    }







    sqlite3_close(db);

    if (!s_db->client_address) {
        return 0;
    }
    return 1;
}
int db_change_group(long long v, unsigned long client_address, int group_id)
{
    char query[255];
    int ret;
    sqlite3 *db;
    char *errmsg;

    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "update address set client_address=%ld , bu_group_id=%d where mac_address=%lld", client_address, group_id, v);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    sqlite3_close(db);
	return 1;
}


int db_list_address()
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select mac_address,bu_group_id, client_address, name from address order by bu_group_id");

    rc = sqlite3_exec(db, query, select_address_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;
}

int db_group_list()
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, name, router_address, broadcast_address, dns_address, domain, wins_address from bu_group");

    rc = sqlite3_exec(db, query, select_group_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;
}









int db_verify_natacl_group(int group)
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;
    struct s_db_hdr s_db;

    char query[255];

    memset(&s_db, 0x00, sizeof(struct s_db_hdr));

    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id from group_policys where bu_group_id='%d' and type='natacl'", group);

    rc = sqlite3_exec(db, query, select_natacl_group_callback, &s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        sqlite3_close(db);

        return 0;
    }

    sqlite3_close(db);
    return s_db.natacl;
}
int get_idgroup_byname(char *name, struct s_db_hdr *s_db)
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, router_address, broadcast_address, dns_address, domain , wins_address from bu_group where name='%s'", name);

    rc = sqlite3_exec(db, query, select_groupid2_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;
}
int get_last_group_ip(int group)
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];

    struct s_db_hdr s_db;

    memset(&s_db, 0x00, sizeof(struct s_db_hdr));

    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select client_address from address where bu_group_id='%d' order by client_address", group);

    rc = sqlite3_exec(db, query, select_last_ip_callback, &s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    if (s_db.last_address == 0) {
        return 0;
    }
    return s_db.last_address + 1;
}
int get_nataclgroup_by_groupid(struct s_db_hdr * s_db, int group_id)
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];

	s_db->s_natacl.id = 0;
	

    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, bu_group_id, config from group_policy where bu_group_id=%d and type='natacl'", group_id );

    rc = sqlite3_exec(db, query, select_natacl_group_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;
}
int db_del_group( int group_id )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];

    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "delete from address where address.bu_group_id=%d", group_id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    snprintf(query, 255, "delete from bu_group where id=%d", group_id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    sqlite3_close(db);

    return 1;
}
int db_policy_list( int argc, char ** argv )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select group_policy.id, bu_group.name, group_policy.type, group_policy.config, group_policy.address, group_policy.port from group_policy, bu_group where group_policy.bu_group_id=bu_group.id");

    rc = sqlite3_exec(db, query, select_policy_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;

}
int db_client_policy_list( unsigned long long mac_address )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, type, config, address, port from client_policy where mac_address=%lld",mac_address);

    rc = sqlite3_exec(db, query, select_client_policy_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;

}
int db_policy_del( int id )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "delete from group_policy where id=%d", id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;

}
int db_client_policy_del( int id )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "delete from client_policy where id=%d", id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);

    return 1;

}
