/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#define __USE_BSD               /* GLIBC */
#define _BSD_SOURCE             /* LIBC5 */


#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>
#include <signal.h>

#include <netinet/in_systm.h>
#include <netinet/in.h>
#include <netinet/ip.h>
#include <netinet/ip_icmp.h>
#include <netinet/tcp.h>
#include <netinet/udp.h>


#include <openssl/ssl.h>
#include <list.h>

#include <socket_tools.h>
#include <sqlite3.h>

#include "../common/db.h"
#include <NatACL.h>


#include "../common/file.h"
#include "../common/parser.h"
#include "../common/iface.h"
#include "log.h"

#include "util.h"
#include "auth.h"
#include "webserver.h"
//#include "../includes/list.h"
void reload(int sg);
struct s_data_hdr * g_data;
void terminate(int sg);

int create_pidfile(int pid)
{
    FILE *fp;

    if (!(fp = fopen("/var/NatACL/NatACL_web.pid", "w+"))) {
        wlog(FILE_LOG, "[ERROR] cannot create file /var/NatACL/NatACL_web.pid");

        perror("/var/NatACL/NatACL_web.pid");
        exit(0);
    }
    fprintf(fp, "%d", pid);
    fflush(fp);
    fclose(fp);

    return 1;
}

char *ntoa_address(char *buffer, unsigned long addr)
{
    struct in_addr in;

    in.s_addr = addr;

    snprintf(buffer, 255, "%s", inet_ntoa(in));

    return buffer;
}

int main(int argc, char **argv)
{
    int sock_webserverlan_listen;
    int sock_webserverlan_ssl_listen;
    int sock_ping;
    int newfd;
    socklen_t sin_len;
    int t;
    int on = 1;
    int i;

    struct sockaddr_in sin;

    struct s_queue_auth_hdr *s_user_walk;

    struct timeval tv;
    struct s_data_hdr s_data;
    struct s_connection_hdr *s_connection_walk;
	struct s_client_hdr * s_client;
	
    fd_set fds;

    sin_len = sizeof(struct sockaddr_in);

    if (getuid() != 0) {
        printf("You must be root\n");
        fflush(stdout);
        exit(0);
    }
    memset(&s_data, 0x00, sizeof(struct s_data_hdr));

	g_data = &s_data;

    SSL_library_init();
    SSL_load_error_strings();

    if ((sock_ping = socket(AF_INET, SOCK_RAW, IPPROTO_ICMP)) < 0) {
        perror("Couldn't open RAW socket");
        return 0;
    }
    if (setsockopt(sock_ping, IPPROTO_IP, IP_HDRINCL, &on, sizeof(on)) < 0) {
        perror("Couldn't setsockopt IP_HDRINCL");
        return 0;
    }

    wlog(FILE_LOG, "[NatACL] Init");
    sock_webserverlan_listen 	 = sock_bind_tcp(5121);
    sock_webserverlan_ssl_listen = sock_bind_tcp(5122);

    printf("Starting Daemon\n");
	fflush(stdout);
    if ((i = fork()) > 0)
        return 0;
    else if (i < 0) {
        exit(1);
    }
    create_pidfile(getpid());
    

/*
	setsid();
	for (i=getdtablesize();i>=0;--i) close(i); 
	i=open("/dev/null",O_RDWR); 
	dup(i); 
	dup(i); 
*/
//    signal(SIGUSR1, reload);
    signal(SIGTERM, terminate);



    s_data.s_db.db = init_db();    
	db_get_group	(s_data.s_db.db, &s_data.s_db);
    db_get_address	(s_data.s_db.db, &s_data.s_db);

    i=0;
    while (1) {
        tv.tv_sec = 0;
        tv.tv_usec = 100000;

        FD_ZERO(&fds);
        FD_SET(sock_webserverlan_listen, &fds);
        FD_SET(sock_webserverlan_ssl_listen, &fds);
        FD_SET(sock_ping, &fds);

        if (s_data.s_fd) {
            s_connection_walk = s_data.s_fd->s_first;
            while (s_connection_walk) {
                FD_SET(s_connection_walk->fd, &fds);

                s_connection_walk = s_connection_walk->s_right;
            }
        }

        select(find_last_fd(s_data.s_fd, sock_webserverlan_ssl_listen) + 1, &fds, NULL, NULL, &tv);

        if (FD_ISSET(sock_webserverlan_listen, &fds)) {
            newfd = accept(sock_webserverlan_listen, (struct sockaddr *) &sin, &sin_len);
            if (verbose > 2) {
                wlog(FILE_LOG, "[SOCKET] [%15s] Connection accepted", inet_ntoa(sin.sin_addr));
            }
            s_data.s_fd = add_queue(s_data.s_fd, newfd);
            snprintf(s_data.s_fd->s_last->source_addr, 64, "%s", inet_ntoa(sin.sin_addr));
        }
        if (FD_ISSET(sock_webserverlan_ssl_listen, &fds)) {
            newfd = accept(sock_webserverlan_ssl_listen, (struct sockaddr *) &sin, &sin_len);
            if (verbose > 2) {
                wlog(FILE_LOG, "[SOCKET] [%15s] Connection accepted", inet_ntoa(sin.sin_addr));
            }
            s_data.s_fd = add_queue(s_data.s_fd, newfd);
            snprintf(s_data.s_fd->s_last->source_addr, 64, "%s", inet_ntoa(sin.sin_addr));

            s_data.s_fd->s_last->ssl = 1;
            if (!init_ssl(s_data.s_fd->s_last)) {
                close(newfd);
                del_queue(s_data.s_fd, s_data.s_fd->s_last);
            }
        }
        if (s_data.s_fd) {
            s_connection_walk = s_data.s_fd->s_first;
            while (s_connection_walk) {
                if (FD_ISSET(s_connection_walk->fd, &fds)) {
                    if (handle_webserver(&s_data, s_connection_walk) == 0) {
                        if (verbose > 2) {
                            wlog(FILE_LOG, "[SOCKET] [%15s] Connection closed", s_data.s_fd->s_last->source_addr);
                        }
                        if (s_connection_walk->keepalive == 2) {
                            s_user_walk = get_user_by_host(s_data.s_user_queue, inet_addr(s_connection_walk->source_addr));

                            wlog(FILE_LOG, "[AUTH] [%20s] Authentication expired - POPUP", s_user_walk->name);

							if((s_client = db_get_single_client_by_address( s_data.s_db.db, ntohl(s_user_walk->source_addr )))){
                            	del_rule(&s_data, s_client);
								db_free_client(  s_client );                            	
							}
                            del_queue_auth(s_data.s_user_queue, s_user_walk);
                        }
                        close(s_connection_walk->fd);
                        sock_buf_close(s_connection_walk->s_buf);

                        s_connection_walk = del_queue(s_data.s_fd, s_connection_walk);


                    } else {
                        s_connection_walk = s_connection_walk->s_right;
                    }
                } else {
                    s_connection_walk = s_connection_walk->s_right;
                }
            }
        }
        if (FD_ISSET(sock_ping, &fds)) {
            handle_ping(&s_data, sock_ping);
        }
        if (s_data.s_user_queue) {
            t = time(NULL);

            s_user_walk = s_data.s_user_queue->s_first;
            while (s_user_walk) {
//		printf("SWALKRTPE: %d\n",s_user_walk->type);
//		fflush(stdout);
                switch (s_user_walk->type) {
                case TYPE_EXPIRE_TIME:
                    if (t > s_user_walk->expire_tv + s_user_walk->logon_tv) {
						if((s_client = db_get_single_client_by_address( s_data.s_db.db, ntohl(s_user_walk->source_addr )))){
                        	del_rule(&s_data, s_client);
							db_free_client(  s_client );                        	
						}

//                        blog_add(FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE);

                        wlog(FILE_LOG, "[AUTH] [%20s] Authentication expired - TIME - %d > %d + %d", s_user_walk->name, t > s_user_walk->expire_tv + s_user_walk->logon_tv);
                        s_user_walk = del_queue_auth(s_data.s_user_queue, s_user_walk);
                    } else {
                        s_user_walk = s_user_walk->s_right;
                    }
                    break;
                case TYPE_EXPIRE_PING:
                    if (t > s_user_walk->ping_tv + PING_INTERVAL) {
                        if (verbose > 5) {
                            wlog(FILE_LOG, "Sending ping");
                        }
                        send_ping(&s_data, sock_ping, s_user_walk->local_address, s_user_walk->source_addr, s_user_walk->source_addr);

                        s_user_walk->ping_tv = t;
                    }

                    if (time(NULL) - s_user_walk->ping_lt > PING_TIMEOUT) {
//                        blog_add(FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE);

                        wlog(FILE_LOG, "[AUTH] [%20s] Authentication expired - PING - %d %d %d", s_user_walk->name, time(NULL), s_user_walk->ping_lt, PING_TIMEOUT);

						if((s_client = db_get_single_client_by_address( s_data.s_db.db, ntohl(s_user_walk->source_addr )))){
                        	del_rule(&s_data, s_client);
							db_free_client(  s_client );
						}

                        s_user_walk = del_queue_auth(s_data.s_user_queue, s_user_walk);
                    } else {
                        s_user_walk = s_user_walk->s_right;
                    }
                    break;
                case TYPE_EXPIRE_PINGTIME:
                    if (t > s_user_walk->ping_tv + PING_INTERVAL) {
                        if (verbose > 5) {
                            wlog(FILE_LOG, "Sending ping- PINGTIME");
                        }
                        send_ping(&s_data, sock_ping, s_user_walk->local_address, s_user_walk->source_addr, s_user_walk->source_addr);

                        s_user_walk->ping_tv = t;
                    }


                    if (t > s_user_walk->logon_tv + s_user_walk->expire_tv) {
						if((s_client = db_get_single_client_by_address( s_data.s_db.db, ntohl(s_user_walk->source_addr )))){
                        	del_rule(&s_data, s_client);
							db_free_client(  s_client );
						}

//                        blog_add(FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE);
                        wlog(FILE_LOG, "[AUTH] [%20s] Authentication expired - TIME - %d > %d + %d", s_user_walk->name, t, s_user_walk->logon_tv, s_user_walk->expire_tv);
                        s_user_walk = del_queue_auth(s_data.s_user_queue, s_user_walk);
                    } else if (time(NULL) - s_user_walk->ping_lt > PING_TIMEOUT) {
                        wlog(FILE_LOG, "[AUTH] [%20s] Authentication expired - PING - %d %d %d", s_user_walk->name, time(NULL), s_user_walk->ping_lt, PING_TIMEOUT);

//                        blog_add(FILE_BIN_LOG, FILE_BIN_IDX, s_user_walk->name, inet_addr(s_user_walk->source), ACTION_REVOKE);
						if((s_client = db_get_single_client_by_address( s_data.s_db.db, ntohl(s_user_walk->source_addr )))){
                        	del_rule(&s_data, s_client);
							db_free_client(  s_client );

						}

                        s_user_walk = del_queue_auth(s_data.s_user_queue, s_user_walk);
                    } else {
                        s_user_walk = s_user_walk->s_right;
                    }
                    break;
                case TYPE_EXPIRE_POPUP:
                    s_user_walk = s_user_walk->s_right;
                    break;
                default:
                    wlog(FILE_LOG, "[ERROR] [EXPIRE] [%20s] Invalid expire method", s_user_walk->name);

                    s_user_walk = s_user_walk->s_right;
                    break;
                }
            }
        }
    }
}

int handle_ping(struct s_data_hdr *s_data, int sock)
{
    socklen_t sinlen;
    char packet[1500];

    unsigned long *t;

    struct s_queue_auth_hdr *s_auth_walk;

    struct ip *s_ip;
    struct icmp *s_icmp;



    sinlen = sizeof(struct sockaddr);

    s_ip = (struct ip *) &packet;
    s_icmp = (struct icmp *) &packet[sizeof(struct ip)];
    t = (unsigned long *) &packet[sizeof(struct ip) + sizeof(struct icmp)];

    recvfrom(sock, packet, 1500, 0, NULL, &sinlen);

    if (!s_data->s_user_queue) {
        return 0;
    }

    if (s_ip->ip_p == IPPROTO_ICMP) {
        s_auth_walk = s_data->s_user_queue->s_first;
        while (s_auth_walk) {
            if (s_icmp->icmp_id == htons(3000) && s_icmp->icmp_seq == 1 && *t == htonl(s_auth_walk->source_addr)) {
                s_auth_walk->ping_lt = time(NULL);
                if (verbose > 2) {
                    wlog(FILE_LOG, "[NatACL] PING ANSWER RECEIVED [%s]", s_auth_walk->name);
                }
                break;
            }
            s_auth_walk = s_auth_walk->s_right;
        }
    }
    return 1;
}
int send_ping(struct s_data_hdr *s_data, int sock, unsigned long source, unsigned long host, unsigned long id)
{
    char packet[1500];
//    int sinlen = sizeof(struct sockaddr);

    unsigned long *t;
    struct ip *s_ip;
    struct icmp *s_icmp;
    struct sockaddr_in sin;

    s_ip = (struct ip *) &packet;
    s_icmp = (struct icmp *) &packet[sizeof(struct ip)];
    t = (unsigned long *) &packet[sizeof(struct ip) + sizeof(struct icmp)];

    memset(packet, 0x00, 1500);

    sin.sin_addr.s_addr = host;
    sin.sin_port = 0;
    sin.sin_family = AF_INET;

    s_ip->ip_src.s_addr = source;
    s_ip->ip_dst.s_addr = host;

    s_ip->ip_v = 4;
    s_ip->ip_hl = sizeof(struct ip) >> 2;
    s_ip->ip_len = sizeof(struct ip) + sizeof(struct icmp) + 4;
    s_ip->ip_id = 3000;
    s_ip->ip_off = 0;
    s_ip->ip_tos = 0;
    s_ip->ip_ttl = 255;
    s_ip->ip_p = IPPROTO_ICMP;
    s_ip->ip_sum = 0;

    s_icmp->icmp_type = ICMP_ECHO;
    s_icmp->icmp_code = 0;
    s_icmp->icmp_cksum = 0;
    s_icmp->icmp_seq = 1;
    s_icmp->icmp_id = htons(3000);

    *t = htonl(id);

    s_icmp->icmp_cksum = in_cksum((u_short *) s_icmp, sizeof(struct icmp) + 4);

    if (sendto(sock, packet, sizeof(struct ip) + sizeof(struct icmp) + 4, 0, (struct sockaddr *) &sin, sizeof(struct sockaddr)) <= 0) {
        perror("sendto");
    }

    return 1;
}

int find_last_fd(struct s_connection *s_fd, int sock1)
{
    int fd;
    struct s_connection_hdr *s_connection_walk;

    fd = sock1;

    if (s_fd) {
        s_connection_walk = s_fd->s_first;
        while (s_connection_walk) {
            if (s_connection_walk->fd > fd) {
                fd = s_connection_walk->fd;
            }
            s_connection_walk = s_connection_walk->s_right;
        }
    }
    return fd;
}
struct s_connection *add_queue(struct s_connection *s_q, int fd)
{
    struct s_connection_hdr *s_fd;

    if (!s_q) {
        s_q = (struct s_connection *) calloc(1, sizeof(struct s_connection));
    }
    s_fd = (struct s_connection_hdr *) calloc(1, sizeof(struct s_connection_hdr));

    if (!s_q->s_first) {
        s_q->s_first = s_fd;
    } else {
        s_fd->s_right = NULL;
        s_fd->s_left = s_q->s_last;
        s_q->s_last->s_right = s_fd;
    }
    s_q->s_last = s_fd;

    s_fd->fd = fd;

    return s_q;
}
struct s_connection_hdr *del_queue(struct s_connection *s_q, struct s_connection_hdr *s_fd)
{
    struct s_connection_hdr *s_tmp;

    s_tmp = s_fd->s_right;

    if (s_q->s_last == s_fd)
        s_q->s_last = s_fd->s_left;

    if (s_q->s_first == s_fd)
        s_q->s_first = s_fd->s_right;

    if (s_fd->s_left) {
        s_fd->s_left->s_right = s_fd->s_right;
    }
    if (s_fd->s_right) {
        s_fd->s_right->s_left = s_fd->s_left;
    }
    free(s_fd);

    return s_tmp;
}

int add_rule(struct s_data_hdr *s_data, struct s_client_hdr * s_client,  struct s_queue_auth_hdr * s_user, char *source_address)
{
	int status;
	struct in_addr in;
	char firewall_rule[255];


    wlog(FILE_LOG, "[GRANT] Added granted rule to [%s]", source_address);
    
	in.s_addr = ntohl( s_client->client_address );

    snprintf(firewall_rule, 255, "iptables -t nat -F NatACL_web_%02x%02x%02x%02x%02x%02x", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);

    if((status= system(firewall_rule)) >0 ){
    	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
    }

    if (s_client->s_client_policy) {
        handle_policy(&s_data->s_db,s_client, s_client->s_client_policy, 0 );
        handle_policy_exec(s_client, s_client->s_client_policy, 0 );
    }
    if (s_client->s_group_policy) {                            
        handle_policy(&s_data->s_db, s_client, s_client->s_group_policy, 0 );
        handle_policy_exec(s_client, s_client->s_group_policy, 0 );
    }
	
    return 1;
}
int handle_policy(struct s_db_hdr * s_db, struct s_client_hdr *s_client, struct s_list *s_l,  int check_natacl)
{
    char str_client_address[64];
//    char str_router_address[64];
    char str_dnat_address[64];
    char str_snat_address[64];
    char str_router_address[64];
    char str_mask_address[64];
    char firewall_rule[255];
    struct s_list_hdr *s_walker;
    int have_natacl = 0;
    struct s_db_policy *s_policy;
    struct s_iface_hdr s_iface;
    struct s_db_group  * s_group;
	int status;
	
    if (s_l) {
        s_walker = s_l->s_first;
        while (s_walker) {
            s_policy = (struct s_db_policy *) s_walker->data;
            if (check_natacl && s_policy->type == TYPE_NATACL) {
                wlog(FILE_LOG, "[%02x:%02x:%02x:%02x:%02x:%02x] [NATACL GROUP FOUND- RUNNING IPTABLES]", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4],
                     s_client->mac_address[5]);

                snprintf(firewall_rule, 255, "iptables -t nat -A NatACL_web_%02x%02x%02x%02x%02x%02x -p tcp -s %s -d 0/0 --dport 80 -j REDIRECT --to-port 5121", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5] ,ntoa_address(str_client_address, htonl(s_client->client_address)));
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }

                have_natacl = 1;
            }

            if (!have_natacl && s_policy->type == TYPE_SNAT) {
                if (get_iface_by_address(&s_iface, ntohl(s_policy->snat_address))) {
                    wlog(FILE_LOG, "[%02x:%02x:%02x:%02x:%02x:%02x] [SNAT GROUP FOUND- RUNNING IPTABLES]", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);

                    snprintf(firewall_rule, 255, "iptables -t nat -o %s  -A NatACL_snat_%02x%02x%02x%02x%02x%02x  -p all -s %s -j SNAT --to-source %s", s_iface.name, s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_client_address, htonl(s_client->client_address)),ntoa_address(str_snat_address, s_policy->snat_address));
	                if((status= system(firewall_rule)) >0 ){
	                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
	                }
                    snprintf(firewall_rule, 255, "iptables -t nat -A NatACL_snat  -j NatACL_snat_%02x%02x%02x%02x%02x%02x ",  s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);
	                if((status= system(firewall_rule)) >0 ){
	                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
	                }
                }
            }
            if (!have_natacl && s_policy->type == TYPE_DNAT) {
                wlog(FILE_LOG, "[%02x:%02x:%02x:%02x:%02x:%02x] [DNAT GROUP FOUND- RUNNING IPTABLES]", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4],
                     s_client->mac_address[5]);

                snprintf(firewall_rule, 255, "iptables -t nat -A NatACL_dnat_%02x%02x%02x%02x%02x%02x  -p tcp -s %s -d 0/0 --dport 80 -j DNAT --to-destination %s:%d", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_client_address, htonl(s_client->client_address)), ntoa_address(str_dnat_address, s_policy->dnat_address), s_policy->dnat_port);
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }

                snprintf(firewall_rule, 255, "iptables -t nat -A NatACL_dnat  -j NatACL_dnat_%02x%02x%02x%02x%02x%02x ",  s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }

            }
            
            if (!have_natacl && s_policy->type == TYPE_GROUP) {
                wlog(FILE_LOG, "[%02x:%02x:%02x:%02x:%02x:%02x] [NETWORK GROUP ACCESS FOUND - ACCESS TO GROUP %s GRANTED]", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4],
                     s_client->mac_address[5],s_policy->config);

				memset( &s_group, 0x00, sizeof( struct s_db_group ));
				
				if((s_group= cache_get_group_by_name( s_db->s_groups, s_policy->config )) ){
	                snprintf(firewall_rule, 255, "iptables -D NatACL_fwd_%02x%02x%02x%02x%02x%02x  -p all -s %s -m mac --mac-source %02x:%02x:%02x:%02x:%02x:%02x -d %s/%s -j NatACL_LOGDROP", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_client_address, htonl(s_client->client_address)), s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_router_address, htonl(s_group->router_address)),ntoa_address(str_mask_address, htonl(s_group->netmask_address)));
				    if((status= system(firewall_rule)) >0 ){
				    	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
				    }
			    }
            }
            s_walker = s_walker->s_right;
        }
    }
    return 1;
}

int handle_policy_exec(struct s_client_hdr *s_client, struct s_list *s_l, int check_natacl)
{
    struct s_list_hdr *s_walker;
//    int have_natacl = 0;
    struct s_db_policy *s_policy;
    char command[255];
    char option[255];
    struct in_addr in;

	if( ! check_natacl && time(NULL) > s_client->exec_tv + 300 ){
	    if (s_l) {
	        s_walker = s_l->s_first;
	        while (s_walker) {
	            s_policy = (struct s_db_policy *) s_walker->data;
	            if ( s_policy->type == TYPE_EXEC) {
	                if (get_option("COMMAND", s_policy->config, option, 255)) {             
	                    wlog(FILE_LOG, "[%02x:%02x:%02x:%02x:%02x:%02x] [EXEC %s]", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5], s_policy->config);
	
	                    in.s_addr = ntohl(s_client->client_address);
	
	                    snprintf(command, 255, "%s %s >/dev/null 2>/dev/null", option, inet_ntoa(in));
	
	                    system(command);
	                }
	            }
	            s_walker = s_walker->s_right;
	        }
	    }
	    s_client->exec_tv = time(NULL);
	}
    return 1;
}

int del_rule(struct s_data_hdr *s_data, struct s_client_hdr * s_client )
{

//    struct s_db_hdr s_db;
    char str_client_address[64];
	struct in_addr in;
	char firewall_rule[255];
    struct s_db_group  * s_group;

	char str_snat_address[64];
	char str_dnat_address[64];
	char str_router_address[64];
	char str_mask_address[64];

	struct s_db_policy * s_policy;
	struct s_list_hdr * s_walker;
    struct s_iface_hdr s_iface;
    int status;
    
	
	in.s_addr = ntohl(s_client->client_address);
//    memset( &s_db , 0x00, sizeof( struct s_data_hdr ));
    wlog(FILE_LOG, "[GRANT] DELETE rule  [%s]", inet_ntoa( in ));
    
	in.s_addr = ntohl( s_client->client_address );

    snprintf(firewall_rule, 255, "iptables -t nat -F NatACL_web_%02x%02x%02x%02x%02x%02x", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);

    if((status= system(firewall_rule)) >0 ){
    	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
    }

    snprintf(firewall_rule, 255, "iptables -t nat -I NatACL_web_%02x%02x%02x%02x%02x%02x -p tcp -s %s -d 0/0 --dport 80 -j REDIRECT --to-port 5121", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5] ,ntoa_address(str_client_address, htonl(s_client->client_address)));
	system( firewall_rule );

	
	if( s_client->s_client_policy ){
		s_walker = s_client->s_client_policy->s_first;
		while( s_walker ){
			s_policy = (struct s_db_policy * )s_client->s_client_policy->s_first->data;
			if( s_policy->type == TYPE_SNAT ){
				in.s_addr = ntohl( s_client->client_address );


                snprintf(firewall_rule, 255, "iptables -t nat -o %s  -D NatACL_snat_%02x%02x%02x%02x%02x%02x  -p all -s %s -j SNAT --to-source %s", s_iface.name, s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_client_address, htonl(s_client->client_address)),ntoa_address(str_snat_address, s_policy->snat_address));
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }
                snprintf(firewall_rule, 255, "iptables -t nat -D NatACL_snat  -j NatACL_snat_%02x%02x%02x%02x%02x%02x ",  s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }

			}
			if( s_policy->type == TYPE_DNAT ){
                snprintf(firewall_rule, 255, "iptables -t nat -D NatACL_dnat_%02x%02x%02x%02x%02x%02x  -p tcp -s %s -d 0/0 --dport 80 -j DNAT --to-destination %s:%d", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_client_address, htonl(s_client->client_address)), ntoa_address(str_dnat_address, s_policy->dnat_address), s_policy->dnat_port);
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }

                snprintf(firewall_rule, 255, "iptables -t nat -D NatACL_dnat  -j NatACL_dnat_%02x%02x%02x%02x%02x%02x ",  s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5]);
                if((status= system(firewall_rule)) >0 ){
                	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
                }
			}
			if( s_policy->type == TYPE_GROUP ){
				memset( &s_group, 0x00, sizeof( struct s_db_group ));
				
				if((s_group= cache_get_group_by_name( s_data->s_db.s_groups, s_policy->config )) ){
	                snprintf(firewall_rule, 255, "iptables -I NatACL_fwd_%02x%02x%02x%02x%02x%02x  -p all -s %s -m mac --mac-source %02x:%02x:%02x:%02x:%02x:%02x -d %s/%s -j NatACL_LOGDROP", s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_client_address, htonl(s_client->client_address)), s_client->mac_address[0], s_client->mac_address[1], s_client->mac_address[2], s_client->mac_address[3], s_client->mac_address[4], s_client->mac_address[5],ntoa_address(str_router_address, htonl(s_group->router_address)),ntoa_address(str_mask_address, htonl(s_group->netmask_address)));
				    if((status= system(firewall_rule)) >0 ){
				    	wlog(FILE_LOG, "COMMAND FAILURE [%d]: %s", status, firewall_rule );
				    }
			    }
			}
			s_walker = s_walker->s_right;
		}	
	}
    return 1;

}

int check_user_logged(struct s_queue_auth *s_q, char *user)
{
    struct s_queue_auth_hdr *s_fd;

    if (!s_q) {
        return 0;
    }

    s_fd = s_q->s_first;
    while (s_fd) {
        if (strcmp(s_fd->name, user) == 0) {
            return 1;
        }
        s_fd = s_fd->s_right;
    }
    return 0;
}
struct s_queue_auth_hdr *get_user_by_host(struct s_queue_auth *s_q, unsigned long addr)
{
    struct s_queue_auth_hdr *s_fd;

    if (!s_q) {
        return NULL;
    }

    s_fd = s_q->s_first;
    while (s_fd) {
        if (s_fd->source_addr == addr) {
            return s_fd;
        }
        s_fd = s_fd->s_right;
    }
    return NULL;
}
struct s_queue_auth *add_queue_auth(struct s_queue_auth *s_q, char *name, int tv, int type, int lt, unsigned long source_address, unsigned long local_address)
{
    struct in_addr in;
    struct s_queue_auth_hdr *s_fd;

    if (!s_q) {
        s_q = (struct s_queue_auth *) calloc(1, sizeof(struct s_queue_auth));
    }
    s_fd = (struct s_queue_auth_hdr *) calloc(1, sizeof(struct s_queue_auth_hdr));

    if (!s_q->s_first) {
        s_q->s_first = s_fd;
    } else {
        s_fd->s_right = NULL;
        s_fd->s_left = s_q->s_last;
        s_q->s_last->s_right = s_fd;
    }
    s_q->s_last = s_fd;

    snprintf(s_fd->name, 64, "%s", name);

    s_fd->logon_tv = tv;
    s_fd->expire_tv = lt;
    s_fd->type = type;
    s_fd->local_address = local_address;
    s_fd->ping_lt = time(NULL);

    s_fd->source_addr = source_address;

    in.s_addr = source_address;
    snprintf(s_fd->source, 20, "%s", inet_ntoa(in));




    return s_q;
}
struct s_queue_auth_hdr *del_queue_auth(struct s_queue_auth *s_q, struct s_queue_auth_hdr *s_fd)
{
    struct s_queue_auth_hdr *s_tmp;

    s_tmp = s_fd->s_right;

    if (s_q->s_last == s_fd)
        s_q->s_last = s_fd->s_left;

    if (s_q->s_first == s_fd)
        s_q->s_first = s_fd->s_right;

    if (s_fd->s_left) {
        s_fd->s_left->s_right = s_fd->s_right;
    }
    if (s_fd->s_right) {
        s_fd->s_right->s_left = s_fd->s_left;
    }
    free(s_fd);

    return s_tmp;
}


int init_ssl(struct s_connection_hdr *s_connection)
{
    if (!(s_connection->ssl_client_ctx = SSL_CTX_new(SSLv23_server_method()))) {
        wlog(FILE_LOG, "[ERROR] [SSL] SSL_CTX_new");
        return 0;
    }

    if (SSL_CTX_use_certificate_file(s_connection->ssl_client_ctx, CERT_FILE, SSL_FILETYPE_PEM) <= 0) {
        wlog(FILE_LOG, "[ERROR] [SSL] SSL_CTX_use_certificate_file");
        return 0;
    }

    if (SSL_CTX_use_PrivateKey_file(s_connection->ssl_client_ctx, CERT_FILE, SSL_FILETYPE_PEM) <= 0) {
        wlog(FILE_LOG, "[ERROR] [SSL] SSL_CTX_use_PrivateKey_file");
        return 0;
    }
    if (SSL_CTX_check_private_key(s_connection->ssl_client_ctx) <= 0) {
        wlog(FILE_LOG, "[ERROR] [SSL] SSL_CTX_check_private");
        return 0;
    }

    if (!(s_connection->ssl_client = SSL_new(s_connection->ssl_client_ctx))) {
        wlog(FILE_LOG, "[ERROR] [SSL] SSL_new");
        return 0;
    }


    if (SSL_set_fd(s_connection->ssl_client, s_connection->fd) <= 0) {
        wlog(FILE_LOG, "[ERROR] [SSL] SSL_set_fd");
        return 0;
    }

    if (SSL_accept(s_connection->ssl_client) <= 0) {
        return 0;
    }

    return 1;
}
void reload(int sg)
{
    wlog(FILE_LOG, "[INFO] RELOAD");


    wlog(FILE_LOG, "[INFO] Cleaning cache");
  //  free_memory(&g_data->s_db);

    wlog(FILE_LOG, "[INFO] Loading dabatase in memory");
//    db_get_group(g_data->s_db.db, &g_data->s_db);
 //   db_get_address(g_data->s_db.db, &g_data->s_db);
}
int get_natacl_dhcp_pid()
{
	FILE * fp;
	char buffer[255];
	int value=0;
	
	if(!(fp = fopen("/var/NatACL/NatACL_dhcp.pid","r"))){
        printf( "[ERROR] cannot open file /var/NatACL/NatACL_dhcp.pid - Please restart NatACL_dhcp");

		perror("/var/NatACL/NatACL_dhcp.pid");
		exit ( 0 );
	}
	fread( buffer, 255, 1, fp );

	fclose(fp);

	value = atoi( buffer );
	
	if( value<=0 ){
		printf("NatACL_dhcp process not found, Please restart NatACL_dhcp\n");
		fflush(stdout);
	}
	
	return value;
}
int reload_dhcp()
{
	int pid = get_natacl_dhcp_pid()	;
	
	printf("Sending signal to PID: %d\n", pid );
	fflush(stdout);
	
	kill( pid, 10 );
	return 1;
}
void terminate(int sg)
{
    wlog(FILE_LOG, "[INFO] Terminating");
	unlink( "/var/NatACL/NatACL_web.pid" );
	reload_dhcp();
	exit(0);
}
