/***************************************************************************
    begin                : Sun Oct 05
    copyright            : (C) 2003 by Fabio Yasusi Yamamoto
    email                : fabio@hostname.org
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <stdio.h>
#include <stdarg.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/un.h>
#include <sys/errno.h>
#include <fcntl.h>
#include <sys/stat.h>
#include <time.h>
#include <arpa/inet.h>
#include <dlfcn.h>

#include <dirent.h>

#include <openssl/ssl.h>
#include <sqlite3.h>

#include "../includes/list.h"
#include "../common/db.h"
#include "NatACL.h"

#include "auth.h"
#include "../common/file.h"
#include <parser.h>

struct s_user_hdr *auth_vrfy(struct s_data_hdr * s_data, struct s_client_hdr * s_client, char *login, char *password, char *address)
{
    struct s_user_hdr *s_user = NULL;
    struct dirent *sDirent;
    int logged = 0;
    int process = 0;
    DIR *sDir;
	char buffer[255];
	
	struct s_db_policy * s_policy;
	
//	s_db = db_select_natacl_by_ip( inet_addr( address ) );

	s_policy = db_get_natacl_from_client( s_client );

	if( !s_policy ){
        wlog(FILE_LOG, "[AUTH] [%15s] [%15s] NOT FOUND IN DHCP/NATACL DATABASE", address, login);
		return NULL;
	}
	
    logged = check_user_logged(s_data->s_user_queue, login);

	
    if (logged) {
    	get_option( "MULTIPLE_SESSIONS", s_policy->config, buffer, 255 );
    	
        if (atoi( buffer )) {
            process = 1;
        }
    } else {
        process = 1;
    }
    get_option( "NAME", s_policy->config, buffer, 255 );
    
    if (process) {
        if ((sDir = opendir("/var/NatACL/modules/auth"))) {
        	/* for satety, i scan the directory and check if the filename is the same on the database */
        	/* Just to prevent someone running fake modules as root */
            while ((sDirent = readdir(sDir))) {
                if (strcmp(sDirent->d_name, buffer)==0) {
                    if ((s_user = run_auth_module(s_policy->config, sDirent->d_name, login, password, address))) {
                        wlog(FILE_LOG, "[AUTH] [%15s] [%15s] User Logged", address, login);
                    }
                    break;
                }
            }
        }
    }
    if (s_user == NULL) {
        wlog(FILE_LOG, "[AUTH] [%15s] [%15s] Invalid Password", address, login);
    }
    return s_user;


}
struct s_user_hdr *run_auth_module(char * config, char *fname, char *login, char *password, char *ip)
{
    void *module;
    char filename[255];
    const char *error;
    struct s_user_hdr *s_user;

    snprintf(filename, 255, "/var/NatACL/modules/auth/%s", fname);

    if ((module = dlopen(filename, RTLD_LAZY)) == NULL) {
        fprintf(stderr, "Couldn't open module: %s\n", dlerror());
    }
    run_module = dlsym(module, "run_module");

    if ((error = dlerror())) {
        fprintf(stderr, "Couldn't find module: %s\n", error);
        exit(1);
    }

    s_user = run_module(config, login, password, ip);

    dlclose(module);

    return s_user;
}
