#include <sqlite3.h>

#include<stdio.h>
#include <stdlib.h>
#include <string.h>



#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#include <sys/socket.h>
#include <sys/errno.h>

#include <time.h>

#include "../common/parser.h"
#include "conversion.h"
#include "../includes/list.h"
#include "db.h"
#include "iptables.h" 


sqlite3 * init_db()
{
	sqlite3 *db;
	int rc;
    char *zErrMsg = 0;
	
	rc = sqlite3_open(DB_FILENAME, &db);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        exit( 0 );
    }
	
	return db;
}
int select_have_group_network_access_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
   struct s_db_policy * s_policy = (struct s_db_policy *) p_data;

	s_policy->bu_group_id = atol( p_fields[0] );

	return 0;	
}
int select_group_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
//    unsigned char *mac;
//    long long l_mac;

//    l_mac = atoll(p_fields[0]);
	struct in_addr in;

 

    printf("%2s [%15s]", p_fields[0], p_fields[1] );
    in.s_addr = ntohl(strtoul(p_fields[2], (char **)NULL, 10));
    printf(" ROUTER: %20s", inet_ntoa(in));
    in.s_addr = ntohl(strtoul(p_fields[3], (char **)NULL, 10));
    printf(" BROADCAST: %20s", inet_ntoa(in));
    in.s_addr = ntohl(strtoul(p_fields[4], (char **)NULL, 10));
    printf(" DNS: %20s", inet_ntoa(in));
    in.s_addr = ntohl(strtoul(p_fields[6], (char **)NULL, 10));
    printf(" WINS: %20s", inet_ntoa(in));
    printf(" DOMAIN: %20s", p_fields[5]);
    printf("\n");


    return 0;
}
int select_policy_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    printf("%2s %20s TYPE: %10s CONFIG: %15s ADDRESS: %15s PORT: %s\n",p_fields[0],p_fields[1],p_fields[2],p_fields[3],p_fields[4],p_fields[5] );
    
    return 0;
}
int select_address_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct in_addr in;
    unsigned char *mac;
    long long l_mac;
	int bu_group_id;
	int client_address;
	char name[128];
	
    l_mac = atoll(p_fields[0]);

    bu_group_id = atol(p_fields[1]);
    client_address = strtoul(p_fields[2], (char **)NULL, 10);
    snprintf(name, 128, "%s", p_fields[3]);

    in.s_addr = htonl(client_address);

    mac = (unsigned char *) &l_mac;
//    static char *getname( unsigned long address )

    printf("%02x:%02x:%02x:%02x:%02x:%02x %02d %20s %30s %35s  0x%02x%02x%02x%02x%02x%02x\n", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5], bu_group_id, inet_ntoa(in), name, getname(in.s_addr), mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
    fflush(stdout);


    return 0;
}

int select_client_policy_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    printf("%20s TYPE: %10s CONFIG: %15s ADDRESS: %15s PORT: %s\n",p_fields[0],p_fields[1],p_fields[2],p_fields[3],p_fields[4] );


    
    return 0;
}

int select_list_address_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr * s_db = (struct s_db_hdr *) p_data;

	uint64_t * v;
	struct s_client_hdr s_client;
	struct s_client_hdr * s_c;
	
	memset( &s_client, 0x00, sizeof( struct s_client_hdr ));

	v = ( uint64_t * )s_client.mac_address;
	
    *v = atoll(p_fields[0]);

    s_client.int_mac_address = *v;

    s_client.bu_group_id = atol(p_fields[1]);
    s_client.client_address = strtoul(p_fields[2], (char **)NULL, 10);

    snprintf(s_client.name, 128, "%s", p_fields[3]);

	if(!(s_c=search_client_by_mac( s_db->s_clients, *v ) )){
	    s_db->s_clients = list_add( s_db->s_clients , (char *)&s_client, sizeof( struct s_client_hdr ) );
	} else {
		s_c->bu_group_id = s_client.bu_group_id;
		s_c->client_address = s_client.client_address;
		strncpy( s_c->name, s_client.name, 128 );					
	}
    return 0;
}
int select_single_address_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
	uint64_t * v;
	struct s_client_hdr * s_client= (struct s_client_hdr *) p_data;;	
	
	memset( s_client, 0x00, sizeof( struct s_client_hdr ));

	v = ( uint64_t * )s_client->mac_address;
	
    *v = atoll(p_fields[0]);

    s_client->int_mac_address = *v;

    s_client->bu_group_id = atol(p_fields[1]);
    s_client->client_address = strtoul(p_fields[2], (char **)NULL, 10);

    snprintf(s_client->name, 128, "%s", p_fields[3]);

    return 0;
}
int select_list_group_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr * s_db = (struct s_db_hdr *) p_data;
	struct s_db_group s_group;
	
	memset( &s_group, 0x00, sizeof( struct s_db_group ));

//    snprintf(query, 255, "select id, name, router_address, broadcast_address, dns_address, netmask_address,  domain, wins_address from bu_group");

    s_group.id = atol(p_fields[0]);
    snprintf(s_group.group_name, 64, "%s", p_fields[1]);
    s_group.router_address = strtoul(p_fields[2], (char **)NULL, 10);
    s_group.broadcast_address = strtoul(p_fields[3], (char **)NULL, 10);
    s_group.dns_address = strtoul(p_fields[4], (char **)NULL, 10);
    s_group.netmask_address = strtoul(p_fields[5], (char **)NULL, 10);
    snprintf(s_group.domain, 64, "%s", p_fields[6]);
    s_group.wins_address = strtoul(p_fields[7], (char **)NULL, 10);


	
//	printf("NETMASK : %u | %s\n", s_group.netmask_address,atol(p_fields[5]));
//	fflush(stdout);

    s_db->s_groups = list_add( s_db->s_groups , (char *)&s_group, sizeof( struct s_db_group ) );

    return 0;
}

int select_groupid_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_group *s_group = (struct s_db_group *) p_data;


    snprintf(s_group->group_name, 64, "%s", p_fields[0]);
    s_group->router_address = strtoul(p_fields[1], (char **)NULL, 10);
    s_group->broadcast_address = strtoul(p_fields[2], (char **)NULL, 10);
    s_group->netmask_address = strtoul(p_fields[3], (char **)NULL, 10);
    s_group->dns_address = strtoul(p_fields[4], (char **)NULL, 10);
    snprintf(s_group->domain, 64, "%s", p_fields[5]);
    s_group->wins_address = strtoul(p_fields[6], (char **)NULL, 10);

    return 0;
}
int select_clientgroup_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_client_hdr *s_group = (struct s_client_hdr *) p_data;


    snprintf(s_group->group_name, 64, "%s", p_fields[0]);
    s_group->router_address = strtoul(p_fields[1], (char **)NULL, 10);
    s_group->broadcast_address = strtoul(p_fields[2], (char **)NULL, 10);


    s_group->dns_address = strtoul(p_fields[3], (char **)NULL, 10);
    s_group->netmask_address = strtoul(p_fields[4], (char **)NULL, 10);
    snprintf(s_group->domain, 64, "%s", p_fields[5]);
    s_group->wins_address = strtoul(p_fields[6], (char **)NULL, 10);

    return 0;
}
int select_group_policy_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_client_hdr * s_client = (struct s_client_hdr *) p_data;
    struct s_db_policy s_policy;
    
    memset( &s_policy, 0x00, sizeof( struct s_db_policy ));
    
    s_policy.id 			= atol(p_fields[0]);
    s_policy.bu_group_id 	= atol(p_fields[1]);


    if( strcmp( p_fields[2],"natacl" ) == 0 ){
		snprintf(s_policy.config, 1024, "%s", p_fields[3]);    
		s_policy.type = TYPE_NATACL;

		s_client->s_group_policy = list_add( s_client->s_group_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
    }
    if( strcmp( p_fields[2],"snat" ) == 0 ){
        s_policy.snat_address = inet_addr( p_fields[4] );
		s_policy.type = TYPE_SNAT;

		s_client->s_group_policy = list_add( s_client->s_group_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
    }
    if( strcmp( p_fields[2],"dnat" ) == 0 ){
        s_policy.dnat_address = inet_addr( p_fields[4]);
		s_policy.dnat_port = atol(p_fields[5]);
		s_policy.type = TYPE_DNAT;
		
		s_client->s_group_policy = list_add( s_client->s_group_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
		
    }
    if( strcmp( p_fields[2],"exec" ) == 0 ){
		snprintf(s_policy.config, 1024, "%s", p_fields[3]);    
		s_policy.type = TYPE_EXEC;
		
		s_client->s_group_policy = list_add( s_client->s_group_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
		
    }
    if( strcmp( p_fields[2],"group" ) == 0 ){
		snprintf(s_policy.config, 1024, "%s", p_fields[3]);    
		s_policy.type = TYPE_GROUP;

		
		s_client->s_group_policy = list_add( s_client->s_group_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
		
    }

    return 0;
}
int select_client_policy_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_client_hdr * s_client = (struct s_client_hdr *) p_data;
    struct s_db_policy s_policy;
    memset( &s_policy, 0x00, sizeof( struct s_db_policy ));
    
    s_policy.id 			= atol(p_fields[0]);
    s_policy.bu_group_id 	= atol(p_fields[1]);

    if( strcmp( p_fields[2],"natacl" ) == 0 ){
		snprintf(s_policy.config, 1024, "%s", p_fields[3]);    
		s_policy.type = TYPE_NATACL;

		s_client->s_client_policy = list_add( s_client->s_client_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
    }
    if( strcmp( p_fields[2],"snat" ) == 0 ){
        s_policy.snat_address = inet_addr( p_fields[4] );
		s_policy.type = TYPE_SNAT;

		s_client->s_client_policy = list_add( s_client->s_client_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
    }
    if( strcmp( p_fields[2],"dnat" ) == 0 ){
        s_policy.dnat_address = inet_addr( p_fields[4]);
		s_policy.dnat_port = atol(p_fields[5]);
		s_policy.type = TYPE_DNAT;
		
		s_client->s_client_policy = list_add( s_client->s_client_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
		
    }
    if( strcmp( p_fields[2],"exec" ) == 0 ){
		snprintf(s_policy.config, 1024, "%s", p_fields[3]);    
		s_policy.type = TYPE_EXEC;
		
		s_client->s_client_policy = list_add( s_client->s_client_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
		
    }

    if( strcmp( p_fields[2],"group" ) == 0 ){
		snprintf(s_policy.config, 1024, "%s", p_fields[3]);    
		s_policy.type = TYPE_GROUP;
		
		s_client->s_client_policy = list_add( s_client->s_client_policy, ( char *)&s_policy, sizeof( struct s_db_policy ));
		
    }

    return 0;
}

struct s_list * db_get_address(sqlite3 *db, struct s_db_hdr * s_db )
{
    char *zErrMsg = 0;
    int rc;
//    struct s_list * s_list=calloc( 1, sizeof( struct s_list ) );
    struct s_list_hdr * s_walker;
    struct s_client_hdr * s_client;

    char query[255];
  
    snprintf(query, 255, "select mac_address, bu_group_id, client_address, name from address");


    rc = sqlite3_exec(db, query, select_list_address_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);

        return 0;
    }
    if( s_db->s_clients ){
	    s_walker = s_db->s_clients->s_first;
	    while( s_walker ){
	    	s_client = ( struct s_client_hdr * )s_walker->data;
				
			db_client_prop(db, s_client, s_client->mac_address );
	    	
	    	s_walker = s_walker->s_right;	
	    }
    }
    return s_db->s_clients;
}
struct s_client_hdr * db_get_single_client_by_address(sqlite3 *db, uint32_t client_address )
{
    char *zErrMsg = 0;
	char query[255];
	int local_db=0;
	int rc;
	struct s_client_hdr * s_client = calloc( 1, sizeof( struct s_client_hdr ) );
	
	
	if( db == NULL ){
		local_db = 1;
		
		db=init_db();
	}

    snprintf(query, 255, "select mac_address, bu_group_id, client_address, name from address where client_address='%u'", client_address );
    rc = sqlite3_exec(db, query, select_single_address_callback, s_client, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);

		if( local_db ) 
			sqlite3_close(db);

        return 0;
    }
    
	db_client_prop(db, s_client, s_client->mac_address );

	if( local_db ) 
		sqlite3_close(db);
		
	return s_client;	
}
int db_free_client( struct s_client_hdr * s_client )
{
	if( s_client->s_client_policy )
		list_clear( s_client->s_client_policy );
	if( s_client->s_group_policy )
		list_clear( s_client->s_group_policy );
	
	free( s_client );	
	return 1;
}
struct s_db_policy * db_get_natacl_from_client( struct s_client_hdr * s_client )
{
	struct s_db_policy * s_policy;
	struct s_list_hdr * s_walker;

	if( s_client->s_client_policy ){
		s_walker = s_client->s_client_policy->s_first;
		while( s_walker ){
			s_policy = (struct s_db_policy *)s_walker->data;
			
			if( s_policy->type == TYPE_NATACL ){
				return s_policy;
			} 
			s_walker = s_walker->s_right;
		}	
	}

	if( s_client->s_group_policy ){

		s_walker = s_client->s_group_policy->s_first;
		while( s_walker ){
			s_policy = (struct s_db_policy * )s_walker->data;
			if( s_policy->type == TYPE_NATACL ){
				return s_policy;
			}
			s_walker = s_walker->s_right;
		}	
	}


	return NULL;
	
}




struct s_list * db_get_address_by_mac(sqlite3 *db, struct s_db_hdr * s_db, uint64_t mac_address )
{
    char *zErrMsg = 0;
    int rc;
//    struct s_list * s_list=calloc( 1, sizeof( struct s_list ) );
    struct s_list_hdr * s_walker;
    struct s_client_hdr * s_client;

    char query[255];
  
    snprintf(query, 255, "select mac_address, bu_group_id, client_address, name from address where mac_address='%lld'",( unsigned long long )mac_address);


    rc = sqlite3_exec(db, query, select_list_address_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);

        return 0;
    }
    if( s_db->s_clients ){
	    s_walker = s_db->s_clients->s_first;
	    while( s_walker ){
	    	s_client = ( struct s_client_hdr * )s_walker->data;
	    	if( s_client->int_mac_address == mac_address ){    	
				db_client_prop(db, s_client, s_client->mac_address );
	
				break;
	    	}	
	    	s_walker = s_walker->s_right;	
	    }
    }
    return s_db->s_clients;
}

int db_client_prop(sqlite3 *db, struct s_client_hdr *s_client, unsigned char *address)
{
    char *zErrMsg = 0;
    int rc;

    char query[255];

    memcpy( s_client->mac_address, address, 6 );
    
    snprintf(query, 255, "select name, router_address, broadcast_address, dns_address, netmask_address, domain, wins_address from bu_group where id=%d", s_client->bu_group_id);

    rc = sqlite3_exec(db, query, select_clientgroup_callback, s_client, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        return 0;
    }

    snprintf(query, 255, "select id, bu_group_id, type, config, address, port from group_policy where bu_group_id=%d",  s_client->bu_group_id);
		
    rc = sqlite3_exec(db, query, select_group_policy_callback, s_client, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        return 0;
    }

    snprintf(query, 255, "select id, mac_address, type, config, address, port from client_policy where mac_address=%lld", ( unsigned long long)s_client->int_mac_address );
		
    rc = sqlite3_exec(db, query, select_client_policy_callback, s_client, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        return 0;
    }

    if (!s_client->client_address) {
        return 0;
    }
    return 1;
}
struct s_client_hdr * search_client_by_ip( struct s_list * s_l, uint32_t address )
{
	struct s_list_hdr * s_walker;
	struct s_client_hdr * s_client;
	
	if( s_l ){	
		s_walker = s_l->s_first;
		while( s_walker ){
			s_client = ( struct s_client_hdr *)s_walker->data;
		
			if( s_client->client_address == address ){
				return s_client;		
			} 
			s_walker = s_walker->s_right;
		}
	}
	return NULL;
}

struct s_client_hdr * search_client_by_mac( struct s_list * s_l, uint64_t mac_address )
{
	struct s_list_hdr  * s_walker;
	struct s_client_hdr * s_client;

	if( s_l ){	
		s_walker = s_l->s_first;
		while( s_walker ){
			s_client = ( struct s_client_hdr *)s_walker->data;


			if( s_client->int_mac_address == mac_address ){
				return s_client;		
			} 
			s_walker = s_walker->s_right;
		}
	}
	return NULL;
}
int select_group_id_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
	struct s_db_group * s_group = (struct s_db_group *) p_data;


    s_group->bu_group_id = atol(p_fields[0]);
    s_group->router_address = strtoul(p_fields[1], (char **)NULL, 10);
    s_group->broadcast_address = strtoul(p_fields[2], (char **)NULL, 10);
    s_group->netmask_address = strtoul(p_fields[3], (char **)NULL, 10);
    s_group->dns_address = strtoul(p_fields[4], (char **)NULL, 10);
    snprintf(s_group->domain, 64, "%s", p_fields[5]);
    s_group->wins_address = strtoul(p_fields[6], (char **)NULL, 10);

    return 0;
}

int get_group_by_name(sqlite3 *db,char *name, struct s_db_group * s_group)
{
    char *zErrMsg = 0;
    int rc;

    char query[255];

    snprintf(query, 255, "select id, router_address, broadcast_address, netmask_address,dns_address, domain , wins_address from bu_group where name='%s'", name);

    rc = sqlite3_exec(db, query, select_group_id_callback, s_group, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        return 0;
    }

    return 1;
}
int db_insert_client(sqlite3 *db,struct s_db_group *s_group, uint64_t address, char * name, uint32_t client_address )
{
    char query[255];
    int ret;
    char *errmsg;

    snprintf(query, 255, "insert into address ( mac_address, client_address, last_tv, bu_group_id, name ) values (  %lld,%ld,%ld,%d,'%s' )", ( unsigned long long )address, ( unsigned long )client_address, time(NULL), s_group->bu_group_id, name);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
  //  sqlite3_close(db);
    return 1;
}
int free_memory( struct s_db_hdr * s_db )
{
	struct s_list_hdr * s_walker;
	struct s_client_hdr * s_client;
	
	if( s_db->s_clients ){
		s_walker = s_db->s_clients->s_first;
		while( s_walker ){
			s_client = ( struct s_client_hdr *)s_walker->data;

			if( s_client->s_client_policy )
				list_clear( s_client->s_client_policy );
			if( s_client->s_group_policy )
				list_clear( s_client->s_group_policy );

			s_walker = s_walker->s_right;
		}
		
		list_clear( s_db->s_clients );		
	}
	s_db->s_clients = NULL;




	list_clear( s_db->s_groups );		
	s_db->s_groups = NULL;


	return 1;
}
int db_insert_group_policy(sqlite3 * db, int groupid, char * type, char * config, char * address, int port  )
{
    char query[255];
    int ret;
    char *errmsg;

    snprintf(query, 255, "insert into group_policy ( bu_group_id, type, config, address, port ) values (%d,'%s','%s','%s',%d) ", groupid, type, config, address, port );

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    return 1;
}

int db_group_policy_del( sqlite3 * db, int id )
{
    char *zErrMsg = 0;
    int rc;

    char query[255];


    snprintf(query, 255, "delete from group_policy where id=%d", id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    return 1;

}

int db_insert_client_policy(sqlite3 * db, unsigned long long mac_address, char * type, char * config, char * address, int port  )
{
    char query[255];
    int ret;
    char *errmsg;

    snprintf(query, 255, "insert into client_policy ( mac_address, type, config, address, port ) values (%lld,'%s','%s','%s',%d) ", mac_address, type, config, address, port );

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    return 1;
}


int db_client_policy_list( sqlite3 * db, unsigned long long mac_address )
{
    char *zErrMsg = 0;
    int rc;

    char query[255];



    snprintf(query, 255, "select id, type, config, address, port from client_policy where mac_address=%lld",mac_address);

    rc = sqlite3_exec(db, query, select_client_policy_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;

}

int db_client_policy_del( sqlite3* db, int id )
{
    char *zErrMsg = 0;
    int rc;

    char query[255];



    snprintf(query, 255, "delete from client_policy where id=%d", id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;

}
int db_insert_group(sqlite3 * db, char *name, uint32_t router_address, uint32_t broadcast_address,uint32_t netmask_address, char * dns_address, char *wins_address, char *domain)
{
    char query[255];
    int ret;
    char *errmsg;


    snprintf(query, 255, "insert into bu_group ( name, router_address, broadcast_address, netmask_address, dns_address, domain, wins_address ) values (  '%s',%u,%u,%u,%u,'%s',%u )", name, ntohl(router_address), ntohl(broadcast_address),ntohl(netmask_address),
             ntohl(inet_addr(dns_address)), domain, ntohl(inet_addr(wins_address)));

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
    return 1;
}
int db_del_group( sqlite3 *db, int group_id )
{
    char *zErrMsg = 0;
    int rc;

    char query[255];

    snprintf(query, 255, "delete from address where address.bu_group_id=%d", group_id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    snprintf(query, 255, "delete from bu_group where id=%d", group_id );

    rc = sqlite3_exec(db, query, NULL, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;
}
int db_group_list(sqlite3 *db)
{
    char *zErrMsg = 0;
    int rc;

    char query[255];



    snprintf(query, 255, "select id, name, router_address, broadcast_address, dns_address,  domain, wins_address from bu_group");

    rc = sqlite3_exec(db, query, select_group_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;
}

int db_change_group(sqlite3 * db, long long v, unsigned long client_address, int group_id)
{
    char query[255];
    int ret;
    char *errmsg;


    snprintf(query, 255, "update address set client_address=%ld , bu_group_id=%d where mac_address=%lld", client_address, group_id, v);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
	return 1;
}

int db_list_address(sqlite3 *db)
{
    char *zErrMsg = 0;
    int rc;

    char query[255];



    snprintf(query, 255, "select mac_address,bu_group_id, client_address, name from address order by bu_group_id");

    rc = sqlite3_exec(db, query, select_address_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;
}
int have_group_network_access( sqlite3 *db, int group_id, char * config  )
{
	int rc;
    char *zErrMsg = 0;
    char query[255];
    struct s_db_policy s_policy;
    
    memset( &s_policy, 0x00, sizeof( struct s_db_policy ));

    snprintf(query, 255, "select id from group_policy where bu_group_id='%d' and type='group' and config='%s'", group_id, config );

    rc = sqlite3_exec(db, query, select_have_group_network_access_callback, &s_policy, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
	
	return s_policy.bu_group_id;	
}
int db_get_group(sqlite3 *db, struct s_db_hdr * s_db )
{
    char *zErrMsg = 0;
    int rc;

    char query[255];

    snprintf(query, 255, "select id, name, router_address, broadcast_address, dns_address, netmask_address,  domain, wins_address from bu_group");

    rc = sqlite3_exec(db, query, select_list_group_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;
}


int db_policy_list( sqlite3 *db, char * name )
{
    char *zErrMsg = 0;
    int rc;

    char query[255];


    snprintf(query, 255, "select group_policy.id, bu_group.name, group_policy.type, group_policy.config, group_policy.address, group_policy.port from group_policy, bu_group where group_policy.bu_group_id=bu_group.id and bu_group.name='%s'", name);

    rc = sqlite3_exec(db, query, select_policy_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }

    return 1;

}

struct s_db_group * cache_get_group_by_name( struct s_list * s_l, char * name )
{
    struct s_list_hdr *s_walker;
	struct s_db_group * s_group;
	
    if (s_l) {
        s_walker = s_l->s_first;
        while (s_walker) {
            s_group = (struct s_db_group *) s_walker->data;
			
			if( strcmp( name, s_group->group_name ) == 0 ){
				return s_group;	
			}
			s_walker = s_walker->s_right;
        }
    }
    return NULL;
}
