#include <stdio.h>
#include <stdlib.h>
#include <string.h>


#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <linux/if.h>
#include <unistd.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>

#include "iface.h"


uint64_t get_iface_by_address(struct s_iface_hdr *iface, uint32_t address)
{


    struct ifreq ifr;
    struct ifreq *IFR;
    struct ifconf ifc;
    char buf[1024];
    int s, i;
    int result = 0;
//    int ok = 0;
//    int sockfd;

//    uint32_t ip;
//    uint32_t netmask;

//    static char mac[6];
//    uint64_t mac;
    struct in_addr in_net;
//    struct in_addr broad;
    struct in_addr in_ip;

    s = socket(AF_INET, SOCK_DGRAM, 0);
    if (s == -1) {
        return -1;
    }

    ifc.ifc_len = sizeof(buf);
    ifc.ifc_buf = buf;
    ioctl(s, SIOCGIFCONF, &ifc);

    IFR = ifc.ifc_req;
    for (i = ifc.ifc_len / sizeof(struct ifreq); --i >= 0; IFR++) {
        strcpy(iface->name, IFR->ifr_name);
        strcpy(ifr.ifr_name, IFR->ifr_name);
//        printf("%s\n", ifr.ifr_name);

        if (ioctl(s, SIOCGIFFLAGS, &ifr) == 0) {
            if (!(ifr.ifr_flags & IFF_LOOPBACK)) {
                if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0) {
                    memcpy((char *) &iface->mac, ifr.ifr_hwaddr.sa_data, 6);

                    if (ioctl(s, SIOCGIFADDR, &ifr) < 0) {
                        perror("ioctl(); SIOCGIFADDR \n");
                        exit(EXIT_FAILURE);
                    }
                    memcpy((void *) &iface->addr, (void *) &ifr.ifr_addr.sa_data + 2, 4);


                    if (ioctl(s, SIOCGIFNETMASK, &ifr) < 0) {
                        perror("ioctl(); SIOCGIFNETMASK \n");
                        exit(EXIT_FAILURE);
                    }
                    memcpy((void *) &iface->netmask, (void *) &ifr.ifr_netmask.sa_data + 2, 4);

                    if (ioctl(s, SIOCGIFBRDADDR, &ifr) < 0) {
                        perror("ioctl(); SIOCGIFBRDADDR \n");
                        exit(EXIT_FAILURE);
                    }
                    memcpy((void *) &iface->broadcast, (void *) &ifr.ifr_netmask.sa_data + 2, 4);

                        if (ioctl(s, SIOCGIFINDEX, &ifr) < 0) {
                            perror("ioctl(); SIOCGIFADDR \n");
                            exit(EXIT_FAILURE);
                        }
                        iface->idx = ifr.ifr_ifindex;


                    in_ip.s_addr = iface->addr;
                    in_net.s_addr = iface->netmask;


                    if (check_if_address_netmask(address, ntohl(iface->addr), ntohl(iface->netmask))) {


//			printf("IDX IDX2: %d\n",ifr.ifr_ifindex );
//			fflush(stdout);

//                        printf("IP FOUND: %s", inet_ntoa(in_ip));
//	                printf("%s\n", inet_ntoa(in_net));
//	        	ff
//lush(stdout);

                        result = 1;
                        break;
                    }
                }
            }
        }
    }

    close(s);
//    printf("FOUND MAC: %llu\n", (unsigned long long) iface->mac);
//    fflush(stdout);
    return result;

}

int get_iface_by_name(struct s_iface_hdr * iface, char *name)
{


    struct ifreq ifr;
    struct ifreq *IFR;
    struct ifconf ifc;
    char buf[1024];
    int s, i;
    int result = 0;
//    int ok = 0;
//    int sockfd;

//    uint32_t ip;
//    uint32_t netmask;

//    static char mac[6];
//    uint64_t mac;
    struct in_addr in_net;
//    struct in_addr broad;
    struct in_addr in_ip;

    s = socket(AF_INET, SOCK_DGRAM, 0);
    if (s == -1) {
        return -1;
    }

    ifc.ifc_len = sizeof(buf);
    ifc.ifc_buf = buf;
    ioctl(s, SIOCGIFCONF, &ifc);

    IFR = ifc.ifc_req;
    for (i = ifc.ifc_len / sizeof(struct ifreq); --i >= 0; IFR++) {
        strcpy(iface->name, IFR->ifr_name);
        strcpy(ifr.ifr_name, IFR->ifr_name);
//        printf("%s\n", ifr.ifr_name);

        if (strcmp(ifr.ifr_name, name) == 0) {
            result = 1;
            if (ioctl(s, SIOCGIFFLAGS, &ifr) == 0) {
                if (!(ifr.ifr_flags & IFF_LOOPBACK)) {
                    if (ioctl(s, SIOCGIFHWADDR, &ifr) == 0) {
                        memcpy((char *) &iface->mac, ifr.ifr_hwaddr.sa_data, 6);

                        if (ioctl(s, SIOCGIFADDR, &ifr) < 0) {
                            perror("ioctl(); SIOCGIFADDR \n");
                            exit(EXIT_FAILURE);
                        }
                        memcpy((void *) &iface->addr, (void *) &ifr.ifr_addr.sa_data + 2, 4);


                        if (ioctl(s, SIOCGIFNETMASK, &ifr) < 0) {
                            perror("ioctl(); SIOCGIFADDR \n");
                            exit(EXIT_FAILURE);
                        }
                        memcpy((void *) &iface->netmask, (void *) &ifr.ifr_netmask.sa_data + 2, 4);

                    if (ioctl(s, SIOCGIFBRDADDR, &ifr) < 0) {
                        perror("ioctl(); SIOCGIFBRDADDR \n");
                        exit(EXIT_FAILURE);
                    }
                    memcpy((void *) &iface->broadcast, (void *) &ifr.ifr_netmask.sa_data + 2, 4);

                        if (ioctl(s, SIOCGIFINDEX, &ifr) < 0) {
                            perror("ioctl(); SIOCGIFADDR \n");
                            exit(EXIT_FAILURE);
                        }
                        iface->idx = ifr.ifr_ifindex;
//			printf("IDX IDX: %d\n",ifr.ifr_ifindex );
//			fflush(stdout);

                        in_ip.s_addr = iface->addr;
                        in_net.s_addr = iface->netmask;

//                        printf("IP: %s %s", inet_ntoa(in_ip), name);
//                        printf("%s\n", inet_ntoa(in_net));
//                        fflush(stdout);
//                 
//                 if( check_if_address_netmask( ntohl(iface->addr), ntohl(iface->netmask) ) ){
//                      result = 1;
//                      break;             
                    }
                }
            }
	    break;
        }
    }


    close(s);
//    printf("FOUND MAC: %llu\n", (unsigned long long) iface->mac);
//    fflush(stdout);
    return result;

}

int check_if_address_netmask(uint32_t vrfy_addr,uint32_t address, uint32_t netmask)
{
//    struct in_addr in;

    unsigned long net;
    unsigned long broad;

//    printf("%ld %ld\n", ( unsigned long )address, ( unsigned long )netmask );
//    fflush(stdout);
    
    
    net = address & netmask;
    broad = address | (~netmask);


//    printf( "%lu %lu %lu %lu",( unsigned long )vrfy_addr , ( unsigned long )net , ( unsigned long )vrfy_addr , ( unsigned long )broad);
    if (vrfy_addr > net && vrfy_addr < broad) {
//	printf("TRUE\n");
        return 1;
    }
//    printf("FALSE\n");
    return 0;
}
