#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include <sys/time.h>

#include "../includes/list.h"

struct s_list * list_add( struct s_list * s_q, char * data, int size )
{
	struct s_list_hdr * s_fd;

	if( !s_q ){
		s_q = ( struct s_list * )calloc( 1, sizeof( struct s_list ) );
	}
	s_fd = ( struct s_list_hdr * )calloc( 1, sizeof( struct s_list_hdr ) );

	if( !s_q->s_first ){
		s_q->s_first = s_fd;
	} else {
		s_fd->s_right     = NULL;
		s_fd->s_left      = s_q->s_last;
		s_q->s_last->s_right   = s_fd;
	}
	s_q->s_last = s_fd;
	
	if( data ){
		s_fd->data = malloc( size + 1 );
		memcpy( s_fd->data, data, size );
		s_fd->data[size]=0x00;
		
		s_fd->data_size = size;
	}
	s_q->count++;
	return s_q;
}

struct s_list_hdr * list_del( struct s_list * s_q, struct s_list_hdr * s_fd )
{
    struct s_list_hdr * s_tmp;

    s_tmp = s_fd->s_right;

    if( s_q->s_last == s_fd )
	s_q->s_last = s_fd->s_left;

    if( s_q->s_first == s_fd )
	s_q->s_first = s_fd->s_right;

    if( s_fd->s_left ){
    	s_fd->s_left->s_right = s_fd->s_right;
    }
    if( s_fd->s_right ){
    	s_fd->s_right->s_left = s_fd->s_left;
    }
    if( s_fd->data ){
    	free( s_fd->data );	
    }
    free( s_fd );

	s_q->count--;

    return s_tmp;
}

int list_clear( struct s_list * s_q )
{
    struct s_list_hdr * s_tmp;

    if( !s_q ){
		return 0;
    }
    s_tmp = s_q->s_first;
    while( s_tmp ){
		s_tmp = list_del( s_q, s_tmp );
    }
    free( s_q );

    return 1;
}
