#include <sqlite3.h>

#include<stdio.h>
#include <stdlib.h>
#include <string.h>



#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#include <sys/socket.h>
#include <sys/errno.h>

#include <time.h>
#include "../common/parser.h"
#include "conversion.h"
#include "../includes/list.h"
#include "db.h"
#include "iptables.h" 



int select_address_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->bu_group_id = atol(p_fields[0]);
    s_db->client_address = atol(p_fields[1]);
    snprintf(s_db->name, 128, "%s", p_fields[2]);

    return 0;
}
int select_list_address_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_list * s_l = (struct s_list *) p_data;
	uint64_t * v;
	struct s_db_hdr s_db;
	
	memset( &s_db, 0x00, sizeof( struct s_db_hdr ));

	v = ( uint64_t * )s_db.mac_address;
	
    *v = atoll(p_fields[0]);

    s_db.bu_group_id = atol(p_fields[1]);
    s_db.client_address = atol(p_fields[2]);
    snprintf(s_db.name, 128, "%s", p_fields[3]);

//	db_search_mac(&db, &s_db, s_db.mac_address );

    s_l = list_add( s_l , (char *)&s_db, sizeof( struct s_db_hdr ) );

    return 0;
}
int select_group_exec_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;
    char chain[255];
    char option[255];
    char command[255];
    int start_hour=-1;
    int start_minute=-1;
    int end_hour=-1;
    int end_minute=-1;
    
    int start_value=0;
    int end_value=0;
    
    struct tm * tm;
    struct in_addr in;
    time_t tv;

    snprintf( chain, 255,"NatACL_exec_0x%02x%02x%02x%02x%02x%02x.%s",  s_db->mac_address[0], s_db->mac_address[1], s_db->mac_address[2], s_db->mac_address[3], s_db->mac_address[4], s_db->mac_address[5] ,p_fields[0]);

 //   if( !chain_vrfy( chain ) ){		
	if( get_option( "START_HOUR", p_fields[1], option, 255 ) ){
	    start_hour=atoi( option );
	}
	if( get_option( "START_MINUTE", p_fields[1], option, 255 ) ){
	    start_minute=atoi( option );
	}
	if( get_option( "END_HOUR", p_fields[1], option, 255 ) ){
	    end_hour=atoi( option );
	}
	if( get_option( "END_MINUTE", p_fields[1], option, 255 ) ){
	    end_minute=atoi( option );
	}
	tv = time(NULL);
    
	in.s_addr = ntohl(s_db->client_address);
	
	tm = localtime( &tv );
	start_value = (start_hour*60)+start_minute;
	end_value   = (end_hour*60)+end_minute;

//	printf("%d %d %d %d\n",tm->tm_hour, tm->tm_min, start_value, end_value );
//	fflush(stdout);	
	if( ( start_hour==-1 && start_minute==-1) || (((tm->tm_hour*60)+tm->tm_min >= start_value) && ((tm->tm_hour*60)+tm->tm_min <= end_value))){
	    if( get_option( "COMMAND", p_fields[1], option, 255 ) ){
		snprintf(command, 255, "%s %s %s >/dev/null 2>/dev/null", option, chain,  inet_ntoa(in) );

		system( command );
//		printf( command );
		
	    }	
	}
//	chain_create( chain );
//    }
    return 0;
}
int select_firewall_group_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
//    struct s_firewall_group s_group_policy;
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->s_group_policy.id = atol(p_fields[0]);
    s_db->s_group_policy.bu_group_id = atol(p_fields[1]);

    if( strcmp( p_fields[2],"natacl" ) == 0 ){
	snprintf(s_db->s_group_policy.config, 1024, "%s", p_fields[3]);    
	s_db->s_group_policy.have_natacl=1;
    }
    if( strcmp( p_fields[2],"snat" ) == 0 ){
        snprintf(s_db->s_group_policy.snat_address, 20, "%s", p_fields[4]);
	s_db->s_group_policy.have_snat=1;
    }
    if( strcmp( p_fields[2],"dnat" ) == 0 ){
        snprintf(s_db->s_group_policy.dnat_address, 20, "%s", p_fields[4]);
	s_db->s_group_policy.dnat_port = atol(p_fields[5]);
	s_db->s_group_policy.have_dnat=1;
    }

//    s_db->s_group_policy = list_add( s_db->s_group_policy , (char *)&s_group_policy, sizeof( struct s_firewall_group ) );

    return 0;
}
int select_natacl_group_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->natacl = atol(p_fields[0]);

    return 0;
}
int select_address_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct in_addr in;
    struct s_db_hdr s_db;
    unsigned char *mac;
    uint64_t l_mac;

    l_mac = atoll(p_fields[0]);

    s_db.bu_group_id = atol(p_fields[1]);
    s_db.client_address = atol(p_fields[2]);
    snprintf(s_db.name, 128, "%s", p_fields[3]);

    in.s_addr = htonl(s_db.client_address);

    mac = (unsigned char *) &l_mac;
//    static char *getname( uint32_t address )

    printf("%02x:%02x:%02x:%02x:%02x:%02x %02d %20s %30s %35s  0x%02x%02x%02x%02x%02x%02x\n", mac[0], mac[1], mac[2], mac[3], mac[4], mac[5], s_db.bu_group_id, inet_ntoa(in), s_db.name, getname(in.s_addr), mac[0], mac[1], mac[2], mac[3], mac[4], mac[5]);
    fflush(stdout);


    return 0;
}
int select_sourcenat_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    snprintf(s_db->source_ip, 20, "%s", p_fields[0]);

    s_db->snat = 1;
    return 0;
}
int select_destinationnat_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    snprintf(s_db->destination_ip, 20, "%s", p_fields[0]);
    s_db->destination_port = atol(p_fields[1]);

    s_db->dnat = 1;

    return 0;
}


int select_groupid_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;


    snprintf(s_db->group_name, 64, "%s", p_fields[0]);
    s_db->router_address = atol(p_fields[1]);
    s_db->broadcast_address = atol(p_fields[2]);
    s_db->dns_address = atol(p_fields[3]);
    snprintf(s_db->domain, 64, "%s", p_fields[4]);
    s_db->wins_address = atol(p_fields[5]);

    return 0;
}
int select_last_ip_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    s_db->last_address = atol(p_fields[0]);

    return 0;
}
int select_groupid2_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;


    s_db->bu_group_id = atol(p_fields[0]);
    s_db->router_address = atol(p_fields[1]);
    s_db->broadcast_address = atol(p_fields[2]);
    s_db->dns_address = atol(p_fields[3]);
    snprintf(s_db->domain, 64, "%s", p_fields[4]);
    s_db->wins_address = atol(p_fields[5]);

    return 0;
}


int db_insert_client(sqlite3 *db,struct s_db_hdr *s_db, uint64_t address)
{
    char query[255];
    int ret;
//    sqlite3 *db;
    char *errmsg;


//    printf("ADDING MAC: %lld\n", ( unsigned long long )address);
//    fflush(stdout);

//    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into address ( mac_address, client_address, last_tv, bu_group_id, name ) values (  %lld,%ld,%ld,%d,'%s' )", ( unsigned long long )address, ( unsigned long )s_db->client_address, time(NULL), s_db->bu_group_id, s_db->name);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
  //  sqlite3_close(db);
    return 1;
}
int db_insert_group(sqlite3 *db,char *name, char *router_address, char *broadcast_address, char *dns_address, char *wins_address, char *domain)
{
    char query[255];
    int ret;
  //  sqlite3 *db;
    char *errmsg;

//    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into bu_group ( name, router_address, broadcast_address, dns_address, domain, wins_address ) values (  '%s',%u,%u,%u,'%s',%u )", name, ntohl(inet_addr(router_address)), ntohl(inet_addr(broadcast_address)),
             ntohl(inet_addr(dns_address)), domain, ntohl(inet_addr(wins_address)));

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
  //  sqlite3_close(db);
    return 1;
}
int db_insert_snat(sqlite3 *db,uint64_t address, char *ip)
{
    char query[255];
    int ret;
   // sqlite3 *db;
    char *errmsg;

//    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into firewall_snat (  mac_address, source_ip  ) values ( %lld, '%s' )", ( unsigned long long )address, ip);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
  //  sqlite3_close(db);
    return 1;
}
int db_insert_dnat(sqlite3 *db,uint64_t address, char *ip, int port)
{
    char query[255];
    int ret;
    //sqlite3 *db;
    char *errmsg;

//    ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "insert into firewall_dnat (  mac_address, destination_ip, destination_port  ) values ( %lld, '%s', %d )", ( unsigned long long )address, ip, port);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
 //   sqlite3_close(db);
    return 1;
}
int db_search_mac(sqlite3 *db, struct s_db_hdr *s_db, unsigned char *address)
{
//    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];
    uint64_t *int_address = (uint64_t *) address;

//    memset(s_db, 0x00, sizeof(struct s_db_hdr));

    memcpy( s_db->mac_address, address, 6 );
    
  //  rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select bu_group_id, client_address, name from address where mac_address=%lld", ( unsigned long long )*int_address);


    rc = sqlite3_exec(db, query, select_address_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
//        sqlite3_close(db);

        return 0;
    }

    snprintf(query, 255, "select name, router_address, broadcast_address, dns_address, domain, wins_address from bu_group where id=%d", s_db->bu_group_id);

    rc = sqlite3_exec(db, query, select_groupid_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
  //      sqlite3_close(db);
        return 0;
    }


    snprintf(query, 255, "select source_ip from firewall_snat where mac_address=%lld", ( unsigned long long )*int_address);

    rc = sqlite3_exec(db, query, select_sourcenat_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    //    sqlite3_close(db);
        return 0;
    }

    snprintf(query, 255, "select destination_ip, destination_port from firewall_dnat where mac_address=%lld", ( unsigned long long )*int_address);

    rc = sqlite3_exec(db, query, select_destinationnat_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
//        sqlite3_close(db);
        return 0;
    }


    snprintf(query, 255, "select id, bu_group_id, type, config, address, port from firewall_group where bu_group_id=%d",  s_db->bu_group_id);
	
    rc = sqlite3_exec(db, query, select_firewall_group_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
  //      sqlite3_close(db);
        return 0;
    }






//    sqlite3_close(db);

    if (!s_db->client_address) {
        return 0;
    }
    return 1;
}
int db_change_group(sqlite3 *db,uint64_t v, uint32_t client_address, int group_id)
{
    char query[255];
    int ret;
    //sqlite3 *db;
    char *errmsg;

 //   ret = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "update address set client_address=%ld , bu_group_id=%d where mac_address=%lld", ( unsigned long ) client_address, group_id,( unsigned long long ) v);

    ret = sqlite3_exec(db, query, 0, 0, &errmsg);

    if (ret != SQLITE_OK) {
        printf("Error in statement: %s [%s].\n", query, errmsg);

    }
  //  sqlite3_close(db);
	return 1;
}

struct s_list * db_get_address(sqlite3 *db)
{
    char *zErrMsg = 0;
    int rc;
    struct s_list * s_list=calloc( 1, sizeof( struct s_list ) );
    struct s_list_hdr * s_walker;
    struct s_db_hdr * s_db;

    char query[255];
  
    snprintf(query, 255, "select mac_address, bu_group_id, client_address, name from address");


    rc = sqlite3_exec(db, query, select_list_address_callback, s_list, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
//        sqlite3_close(db);

        return 0;
    }
    s_walker = s_list->s_first;
    while( s_walker ){
    	s_db = ( struct s_db_hdr * )s_walker->data;
    	
		db_search_mac(db, s_db, s_db->mac_address );
    	
    	s_walker = s_walker->s_right;	
    }
    return s_list;
}

int db_list_address(sqlite3 *db)
{
    //sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


//    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select mac_address,bu_group_id, client_address, name from address order by bu_group_id");

    rc = sqlite3_exec(db, query, select_address_list_callback, NULL, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
 //   sqlite3_close(db);

    return 1;
}
int db_group_exec(sqlite3 *db, struct s_db_hdr * s_db )
{
//    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


  //  rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, config from firewall_group where type='exec' and bu_group_id=%d", s_db->bu_group_id);

    rc = sqlite3_exec(db, query, select_group_exec_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
   // sqlite3_close(db);

    return 1;
}









int db_verify_natacl_group(sqlite3 *db,int group)
{
//    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;
    struct s_db_hdr s_db;

    char query[255];

    memset(&s_db, 0x00, sizeof(struct s_db_hdr));

  //  rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id from natacl_groups where bu_group_id='%d'", group);

    rc = sqlite3_exec(db, query, select_natacl_group_callback, &s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
        sqlite3_close(db);

        return 0;
    }

//    sqlite3_close(db);
    return s_db.natacl;
}
int get_idgroup_byname(sqlite3 *db,char *name, struct s_db_hdr *s_db)
{
//    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];


  //  rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, router_address, broadcast_address, dns_address, domain , wins_address from bu_group where name='%s'", name);

    rc = sqlite3_exec(db, query, select_groupid2_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
//    sqlite3_close(db);

    return s_db->bu_group_id;
}
int get_last_group_ip(sqlite3 *db,int group)
{
//    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];

    struct s_db_hdr s_db;

    memset(&s_db, 0x00, sizeof(struct s_db_hdr));

//    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select client_address from address where bu_group_id='%d' order by client_address", group);

    rc = sqlite3_exec(db, query, select_last_ip_callback, &s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
  //  sqlite3_close(db);

    if (s_db.last_address == 0) {
        return 0;
    }
    return s_db.last_address + 1;
}
