struct s_firewall_group {
	int id;
	int bu_group_id;
	
	char config[1024];
	char snat_address[20];
	char dnat_address[20];
	int dnat_port;
	
	
	int have_natacl;
	int have_snat;
	int have_dnat;
};

struct s_db_hdr {
	struct s_firewall_group s_group_policy; 
	unsigned char mac_address[6];
	char domain [30];
	char group_name[64];
	char name[128];

	uint32_t source_address;
	
	int bu_group_id;	
	uint32_t client_address;
	uint32_t router_address;
	uint32_t broadcast_address;
	uint32_t dns_address;
	uint32_t wins_address;
	
	uint32_t last_address;
	
	int natacl;
	int snat;
	char source_ip[20];
	int dnat;
	char destination_ip[20];
	int destination_port;
	
};
int db_search_mac(sqlite3 *db,struct s_db_hdr *s_db, unsigned char *address);
int get_idgroup_byname( sqlite3 *db,char * name, struct s_db_hdr * s_db  );

int db_verify_natacl_group(sqlite3 *db,int group );
int db_list_address( sqlite3 *db );
int db_change_group( sqlite3 *db,uint64_t v, uint32_t client_address, int group_id );
int db_search_mac(sqlite3 *db,struct s_db_hdr *s_db, unsigned char *address);
int db_insert_dnat( sqlite3 *db,uint64_t address, char * ip, int port);
int db_insert_snat( sqlite3 *db,uint64_t address, char * ip);
int db_insert_group(sqlite3 *db,char *name, char *router_address, char *broadcast_address, char *dns_address, char * wins_address, char *domain);
int db_insert_client(sqlite3 *db,struct s_db_hdr *s_db, uint64_t address);
int get_idgroup_byname( sqlite3 *db,char * name, struct s_db_hdr * s_db  );
int get_last_group_ip( sqlite3 *db,int group  );
int db_group_exec(sqlite3 *db, struct s_db_hdr * s_db );
struct s_list * db_get_address(sqlite3 *db);













