#define __FAVOR_BSD
#define __USE_BSD

#include<stdio.h>
#include <stdlib.h>
#include <string.h>

#include <unistd.h>

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netinet/in_systm.h>

#define __FAVOR_BSD
#include <netinet/ip.h>
#include <netinet/udp.h>

#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <net/ppp_defs.h>
#include <arpa/inet.h>

#include <signal.h>
#include <linux/netdevice.h>
#include <net/ethernet.h>
//#include <netpacket/packet.h>

#include <sys/socket.h>
#include <linux/if.h>
#include <linux/if_arp.h>
#include <linux/if_ether.h>
#include <features.h>
#include <openssl/ssl.h>

#include <socket_tools.h>
#include "iface.h"

#include "dhcp.h"
int dhcp_bind()
{
    int sock;

    sock = sock_bind_udp(67);


    return sock;
}
int dhcp_decode_packet(struct s_dhcp_hdr *s_dhcp, char *packet, int packet_size)
{
    struct s_comm_dhcp *s_comm_dhcp = (struct s_comm_dhcp *) packet;
    unsigned char opt;
    char *options;
    int cursor = 0;
    unsigned char opt_size = 0;
    if (s_comm_dhcp->op != DHCP_OP_BOOTREQUEST) {
        return 0;
    }

    memcpy(s_dhcp->address, s_comm_dhcp->chaddr, 6);

    s_dhcp->id = s_comm_dhcp->xid;


    options = &packet[sizeof(struct s_comm_dhcp)];

    /* MAGIC */
    cursor += 4;

    while (cursor+2 < packet_size) {
        opt = options[cursor++];
        opt_size = options[cursor++];

        switch (opt) {
        case 0x32:
            memcpy(&s_dhcp->requested_client_address, &options[cursor], 4);

            break;
        case 0x35:
            s_dhcp->type = options[cursor];
            break;
        }
        if (opt == 0xff) {
            break;
        }
        cursor += opt_size;
    }
    if (!s_dhcp->requested_client_address) {
        s_dhcp->requested_client_address = s_comm_dhcp->claddr;
    }
    return 1;
}
int mac_addr_idx(char *interface)
{
    struct ifreq ifr;
    int s;

    memset(&ifr, 0x00, sizeof(struct ifreq));

    s = socket(AF_INET, SOCK_DGRAM, 0);
    if (s == -1) {
        return -1;
    }

    strcpy(ifr.ifr_name, interface);
    if (ioctl(s, SIOCGIFFLAGS, &ifr) == 0) {
        if (ioctl(s, SIOCGIFHWADDR, &ifr) != 0) {
            perror("ERRO");
            exit(0);
        }
        if (ioctl(s, SIOCGIFINDEX, &ifr) == 0) {
        }
    }

    close(s);

    return ifr.ifr_ifindex;
}
char *mac_address(char *interface)
{
    static char mac[6];
    struct ifreq ifr;
    int s;

    memset(&ifr, 0x00, sizeof(struct ifreq));

    s = socket(AF_INET, SOCK_DGRAM, 0);
    if (s == -1) {
        return NULL;
    }

    strcpy(ifr.ifr_name, interface);
    if (ioctl(s, SIOCGIFFLAGS, &ifr) == 0) {
        if (ioctl(s, SIOCGIFHWADDR, &ifr) != 0) {
            perror("ERRO");
            exit(0);
        }
        if (ioctl(s, SIOCGIFINDEX, &ifr) == 0) {
        }
    }

    close(s);

    memcpy(mac, ifr.ifr_hwaddr.sa_data, 6);

    return mac;
}

/*unsigned short in_cksum(unsigned short *addr, int len)
{
    register int nleft = len;
    register unsigned short *w = addr;
    register int sum = 0;
    unsigned short answer = 0;

    while (nleft > 1) {
        sum += *w++;
        nleft -= 2;
    }
    if (nleft == 1) {
        *(u_char *) (&answer) = *(u_char *) w;

        sum += answer;
    }
    sum = (sum >> 16) + (sum & 0xffff);
    sum += (sum >> 16);
    answer = ~sum;
    return (answer);
}
*/




int dhcp_send_response_nak(char *interface, struct s_dhcp_hdr *s_dhcp)
{
    struct sockaddr_ll socket_address;

    char buffer[ETH_FRAME_LEN];

    struct ethhdr *eh = (struct ethhdr *) buffer;
    char *data = &buffer[14];

    struct ip *ip = (struct ip *) data;
    struct udphdr *udp = (struct udphdr *) &data[sizeof(struct ip)];
    struct s_comm_dhcp *s_comm_dhcp = (struct s_comm_dhcp *) &data[sizeof(struct ip) + sizeof(struct udphdr)];
    struct s_iface_hdr s_iface;

    char *options = &data[sizeof(struct ip) + sizeof(struct udphdr) + sizeof(struct s_comm_dhcp)];

    int send_result = 0;
//      unsigned char src_mac[6] = {0x00, 0x02, 0x3f, 0x93, 0x09, 0xe2};

    int sock;
    int cursor = 0;
//      char * source_mac = mac_address( "eth1");
    uint64_t smac;



    memset(buffer, 0x00, ETH_FRAME_LEN);

    if ((smac = get_iface_by_address(&s_iface, ntohl(s_dhcp->response_client_address)))) {

        if ((sock = socket(AF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
            perror("socket");
            exit(0);
        }
//      printf("INTEFACE: %d\n", mac_addr_idx ( "eth1" ));
//      fflush(stdout);

        socket_address.sll_family = PF_PACKET;
        socket_address.sll_protocol = htons(ETH_P_IP);
//        printf("IDX: %d\n", s_iface.idx);
//        fflush(stdout);

        socket_address.sll_hatype = ARPHRD_ETHER;
        socket_address.sll_pkttype = PACKET_OTHERHOST;
        socket_address.sll_halen = ETH_ALEN;
        socket_address.sll_ifindex = s_iface.idx;
        socket_address.sll_addr[0] = 0x00;
        socket_address.sll_addr[1] = 0x00;
        socket_address.sll_addr[2] = 0x00;
        socket_address.sll_addr[3] = 0x00;
        socket_address.sll_addr[4] = 0x00;
        socket_address.sll_addr[5] = 0x00;
        socket_address.sll_addr[6] = 0x00;      /*not used */
        socket_address.sll_addr[7] = 0x00;      /*not used */


        /*set the frame header */
        memcpy((void *) buffer, (void *) s_dhcp->address, ETH_ALEN);
        memcpy((void *) (buffer + ETH_ALEN), (void *) &s_iface.mac, ETH_ALEN);
        eh->h_proto = htons(0x0800);

        ip->ip_hl = 5;
        ip->ip_v = 4;
        ip->ip_tos = 0;
        ip->ip_len = htons(sizeof(struct ip) + sizeof(struct udphdr));
        ip->ip_id = htons(68);
        ip->ip_off = 0;
        ip->ip_ttl = 255;
        ip->ip_p = IPPROTO_UDP;
        ip->ip_sum = 0;
        ip->ip_src.s_addr = s_dhcp->response_dhcp_address;
//        if (s_dhcp->source_address == 0) {
            ip->ip_dst.s_addr = inet_addr("255.255.255.255");
//        } else {
//            ip->ip_dst.s_addr = s_dhcp->response_client_address;
//        }
        udp->uh_sport = htons(67);
        udp->uh_dport = htons(68);

        s_comm_dhcp->op = DHCP_OP_BOOTREPLY;
        s_comm_dhcp->htype = 1;
        s_comm_dhcp->hlen = ETH_ALEN;
        s_comm_dhcp->hops = 0;
        s_comm_dhcp->xid = s_dhcp->id;
        s_comm_dhcp->secs = htons(10);
//        s_comm_dhcp->yladdr = s_dhcp->response_client_address;
//        s_comm_dhcp->sladdr = s_dhcp->response_client_address;

        memcpy(s_comm_dhcp->chaddr, s_dhcp->address, 6);

        /* Magic Cookie */
        options[cursor++] = 0x63;
        options[cursor++] = 0x82;
        options[cursor++] = 0x53;
        options[cursor++] = 0x63;


//        switch (s_dhcp->type) {
//        case DHCP_TYPE_DISCOVER:
            cursor = dhcp_option_add_message_type(options, cursor, DHCP_TYPE_NAK);
//            break;
//        case DHCP_TYPE_REQUEST:
//            cursor = dhcp_option_add_message_type(options, cursor, DHCP_TYPE_ACK);
//            break;
//        default:
//            printf("UNKNOWN %d\n", s_dhcp->type);
//            fflush(stdout);
//            cursor = dhcp_option_add_message_type(options, cursor, DHCP_TYPE_ACK);
//            break;
//        }
        cursor = dhcp_option_add_serverid(options, cursor, s_dhcp->response_dhcp_address);

//        cursor = dhcp_option_add_leasetime(options, cursor, 3600);
//        cursor = dhcp_option_add_netmask(options, cursor, 0x00ffffff);
//        cursor = dhcp_option_add_router(options, cursor, s_dhcp->response_router_address);
//        cursor = dhcp_option_add_dns(options, cursor, s_dhcp->response_dns_address);
//        cursor = dhcp_option_add_domain(options, cursor, s_dhcp->response_domain);
//        cursor = dhcp_option_add_broadcast(options, cursor, s_dhcp->response_broadcast_address);
//        cursor = dhcp_option_add_netbiosns(options, cursor, s_dhcp->response_wins_address);
//        cursor = dhcp_option_add_renew(options, cursor, 30);

        /* End Options */
        options[cursor++] = 0xff;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor] = 0x00;

        ip->ip_len = htons(sizeof(struct ip) + sizeof(struct udphdr) + sizeof(struct s_comm_dhcp) + cursor);
        udp->uh_ulen = htons(sizeof(struct udphdr) + sizeof(struct s_comm_dhcp) + cursor);

        ip->ip_sum = in_cksum((unsigned short *) ip, sizeof(struct ip));

        /*send the packet */
        send_result = sendto(sock, buffer, ETH_FRAME_LEN, 0, (struct sockaddr *) &socket_address, sizeof(socket_address));

        close(sock);

    } else {
        printf("CLIENT IFDACE NOT FOUND\n");
        fflush(stdout);
    }
    return 1;
}
int dhcp_send_response(char *interface, struct s_dhcp_hdr *s_dhcp)
{
    struct sockaddr_ll socket_address;

    char buffer[ETH_FRAME_LEN];

    struct ethhdr *eh = (struct ethhdr *) buffer;
    char *data = &buffer[14];

    struct ip *ip = (struct ip *) data;
    struct udphdr *udp = (struct udphdr *) &data[sizeof(struct ip)];
    struct s_comm_dhcp *s_comm_dhcp = (struct s_comm_dhcp *) &data[sizeof(struct ip) + sizeof(struct udphdr)];
    struct s_iface_hdr s_iface;

    char *options = &data[sizeof(struct ip) + sizeof(struct udphdr) + sizeof(struct s_comm_dhcp)];

    int send_result = 0;
//      unsigned char src_mac[6] = {0x00, 0x02, 0x3f, 0x93, 0x09, 0xe2};

    int sock;
    int cursor = 0;
//      char * source_mac = mac_address( "eth1");
    uint64_t smac;



    memset(buffer, 0x00, ETH_FRAME_LEN);

    if ((smac = get_iface_by_address(&s_iface, ntohl(s_dhcp->response_client_address)))) {

        if ((sock = socket(AF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
            perror("socket");
            exit(0);
        }
//      printf("INTEFACE: %d\n", mac_addr_idx ( "eth1" ));
//      fflush(stdout);

        socket_address.sll_family = PF_PACKET;
        socket_address.sll_protocol = htons(ETH_P_IP);
//        printf("IDX: %d\n", s_iface.idx);
//        fflush(stdout);

        socket_address.sll_hatype = ARPHRD_ETHER;
        socket_address.sll_pkttype = PACKET_OTHERHOST;
        socket_address.sll_halen = ETH_ALEN;
        socket_address.sll_ifindex = s_iface.idx;
        socket_address.sll_addr[0] = 0x00;
        socket_address.sll_addr[1] = 0x00;
        socket_address.sll_addr[2] = 0x00;
        socket_address.sll_addr[3] = 0x00;
        socket_address.sll_addr[4] = 0x00;
        socket_address.sll_addr[5] = 0x00;
        socket_address.sll_addr[6] = 0x00;      /*not used */
        socket_address.sll_addr[7] = 0x00;      /*not used */


        /*set the frame header */
        memcpy((void *) buffer, (void *) s_dhcp->address, ETH_ALEN);
        memcpy((void *) (buffer + ETH_ALEN), (void *) &s_iface.mac, ETH_ALEN);
        eh->h_proto = htons(0x0800);

        ip->ip_hl = 5;
        ip->ip_v = 4;
        ip->ip_tos = 0;
        ip->ip_len = htons(sizeof(struct ip) + sizeof(struct udphdr));
        ip->ip_id = htons(68);
        ip->ip_off = 0;
        ip->ip_ttl = 255;
        ip->ip_p = IPPROTO_UDP;
        ip->ip_sum = 0;
        ip->ip_src.s_addr = s_dhcp->response_dhcp_address;
        if (s_dhcp->source_address == 0) {
            ip->ip_dst.s_addr = inet_addr("255.255.255.255");
        } else {
            ip->ip_dst.s_addr = s_dhcp->response_client_address;
        }
        udp->uh_sport = htons(67);
        udp->uh_dport = htons(68);

        s_comm_dhcp->op = DHCP_OP_BOOTREPLY;
        s_comm_dhcp->htype = 1;
        s_comm_dhcp->hlen = ETH_ALEN;
        s_comm_dhcp->hops = 0;
        s_comm_dhcp->xid = s_dhcp->id;
        s_comm_dhcp->secs = htons(10);
        s_comm_dhcp->yladdr = s_dhcp->response_client_address;
        s_comm_dhcp->sladdr = s_dhcp->response_client_address;

        memcpy(s_comm_dhcp->chaddr, s_dhcp->address, 6);

        /* Magic Cookie */
        options[cursor++] = 0x63;
        options[cursor++] = 0x82;
        options[cursor++] = 0x53;
        options[cursor++] = 0x63;


        switch (s_dhcp->type) {
        case DHCP_TYPE_DISCOVER:
            cursor = dhcp_option_add_message_type(options, cursor, DHCP_TYPE_OFFER);
            break;
        case DHCP_TYPE_REQUEST:
            cursor = dhcp_option_add_message_type(options, cursor, DHCP_TYPE_ACK);
            break;
        default:
            printf("UNKNOWN %d\n", s_dhcp->type);
            fflush(stdout);
            cursor = dhcp_option_add_message_type(options, cursor, DHCP_TYPE_ACK);
            break;
        }
        cursor = dhcp_option_add_serverid(options, cursor, s_dhcp->response_dhcp_address);

        cursor = dhcp_option_add_leasetime(options, cursor, 400 );
        cursor = dhcp_option_add_netmask(options, cursor, 0x00ffffff);
        cursor = dhcp_option_add_router(options, cursor, s_dhcp->response_router_address);
        cursor = dhcp_option_add_dns(options, cursor, s_dhcp->response_dns_address);
        cursor = dhcp_option_add_domain(options, cursor, s_dhcp->response_domain);
        cursor = dhcp_option_add_broadcast(options, cursor, s_dhcp->response_broadcast_address);
        cursor = dhcp_option_add_netbiosns(options, cursor, s_dhcp->response_wins_address);
        cursor = dhcp_option_add_renew(options, cursor, 30 );
        cursor = dhcp_option_add_rebind(options, cursor, 200 );

        /* End Options */
        options[cursor++] = 0xff;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor++] = 0x00;
        options[cursor] = 0x00;

        ip->ip_len = htons(sizeof(struct ip) + sizeof(struct udphdr) + sizeof(struct s_comm_dhcp) + cursor);
        udp->uh_ulen = htons(sizeof(struct udphdr) + sizeof(struct s_comm_dhcp) + cursor);

        ip->ip_sum = in_cksum((unsigned short *) ip, sizeof(struct ip));

        /*send the packet */
        send_result = sendto(sock, buffer, ETH_FRAME_LEN, 0, (struct sockaddr *) &socket_address, sizeof(socket_address));

        close(sock);

    } else {
        printf("CLIENT IFDACE NOT FOUND\n");
        fflush(stdout);
    }
    return 1;
}

int dhcp_option_add_message_type(char *buffer, int cursor, int type)
{
    buffer[cursor++] = 0x35;
    buffer[cursor++] = 0x01;
    buffer[cursor++] = type;

    return cursor;
}
int dhcp_option_add_serverid(char *buffer, int cursor, uint32_t addr)
{
    buffer[cursor++] = 0x36;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &addr, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_leasetime(char *buffer, int cursor, uint32_t time)
{
    int t;

    t = htonl(time);

    buffer[cursor++] = 0x33;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &t, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_netmask(char *buffer, int cursor, uint32_t netmask)
{
    buffer[cursor++] = 0x01;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &netmask, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_renew(char *buffer, int cursor, uint32_t value)
{
    int t;

    t = htonl(value);

    buffer[cursor++] = 58;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &t, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_rebind(char *buffer, int cursor, uint32_t value)
{
    int t;

    t = htonl(value);

    buffer[cursor++] = 59;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &t, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_router(char *buffer, int cursor, uint32_t router)
{
    buffer[cursor++] = 0x03;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &router, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_dns(char *buffer, int cursor, uint32_t dns)
{
    buffer[cursor++] = 0x06;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &dns, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_domain(char *buffer, int cursor, char *domain)
{
    buffer[cursor++] = 0x0f;
    buffer[cursor++] = strlen(domain);
    memcpy(&buffer[cursor], domain, strlen(domain));
    cursor += strlen(domain);

    return cursor;
}
int dhcp_option_add_broadcast(char *buffer, int cursor, uint32_t broadcast)
{
    buffer[cursor++] = 0x1c;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &broadcast, 4);
    cursor += 4;

    return cursor;
}
int dhcp_option_add_netbiosns(char *buffer, int cursor, uint32_t ip)
{
    buffer[cursor++] = 0x2c;
    buffer[cursor++] = 0x04;
    memcpy(&buffer[cursor], &ip, 4);
    cursor += 4;

    buffer[cursor++] = 0x2e;
    buffer[cursor++] = 0x01;
    buffer[cursor++] = 0x08;

    return cursor;
}

uint32_t mac_addr_sys(u_char * addr, char *interface)
{
    struct ifreq ifr;
    int s;

    s = socket(AF_INET, SOCK_DGRAM, 0);
    if (s == -1) {
        return -1;
    }

    strcpy(ifr.ifr_name, interface);
    if (ioctl(s, SIOCGIFFLAGS, &ifr) == 0) {
        if (ioctl(s, SIOCGIFHWADDR, &ifr) != 0) {
            perror("ERRO");
            exit(0);
        }
    }
    close(s);
    bcopy(ifr.ifr_hwaddr.sa_data, addr, 6);

    return 0;
}
