#include <stdio.h>
#include <stdlib.h>

#include "database_datalink.h"


struct s_db_datalink *database_datalink_add(struct s_db_datalink *s_db_datalink, unsigned long long address)
{
    struct s_db_datalink_hdr *s_db;
    struct s_db_datalink_hdr *s_walker;


    if (!s_db_datalink) {
        s_db_datalink = calloc(1, sizeof(struct s_db_datalink));

        s_db = calloc(1, sizeof(struct s_db_datalink_hdr));
        s_db->s_right = 0;
        s_db->s_left = 0;
        s_db->first_tv = time(NULL);

        s_db->address = address;

        s_db_datalink->count = 1;

        s_db_datalink->s_first = s_db;
        s_db_datalink->s_last = s_db;
        s_db_datalink->s_cursor = s_db;

        return s_db_datalink;
    }

    s_walker = s_db_datalink->s_first;

    while (s_walker) {
        if (s_walker->address == address) {
            s_walker->last_tv = time(NULL);

            s_db_datalink->s_cursor = s_walker;

            break;
        } else if (s_walker->address > address) {
            if (s_walker->s_right) {
                s_walker = s_walker->s_right;


            } else {
                s_db = calloc(1, sizeof(struct s_db_datalink_hdr));
                s_db->s_right = 0;
                s_db->s_left = 0;
                s_db->first_tv = time(NULL);

                s_db->address = address;

                s_walker->s_right = s_db;

                s_db_datalink->s_cursor = s_db;
                s_db_datalink->count++;


                s_db_datalink->s_last->s_list_right = s_db;
                s_db_datalink->s_last = s_db;
                break;
            }
        } else if (s_walker->address < address) {
            if (s_walker->s_left) {
                s_walker = s_walker->s_left;
            } else {
                s_db = calloc(1, sizeof(struct s_db_datalink_hdr));
                s_db->s_right = 0;
                s_db->s_left = 0;
                s_db->first_tv = time(NULL);

                s_db->address = address;

                s_walker->s_left = s_db;

                s_db_datalink->s_cursor = s_db;
                s_db_datalink->count++;

                s_db_datalink->s_last->s_list_right = s_db;
                s_db_datalink->s_last = s_db;

                break;
            }
        }
    }
    return s_db_datalink;
}
struct s_db_datalink_hdr *database_datalink_search(struct s_db_datalink *s_db_datalink, unsigned long long address)
{
    struct s_db_datalink_hdr *s_walker;
    struct s_db_datalink_hdr *s_db = NULL;


    if (!s_db_datalink) {
        return NULL;
    }

    s_walker = s_db_datalink->s_first;
    while (s_walker) {
        if (s_walker->address == address) {
            s_db = s_walker;

            break;
        } else if (s_walker->address > address) {
            if (s_walker->s_right) {
                s_walker = s_walker->s_right;
            } else {
                break;
            }
        } else if (s_walker->address < address) {
            if (s_walker->s_left) {
                s_walker = s_walker->s_left;
            } else {
                break;
            }
        }
    }
    return s_db;
}
