#include <stdio.h>
#include <stdlib.h>
#include <netinet/in.h>

#include "database_datalink.h"
#include "database_network.h"

struct s_db_network * database_network_add( struct s_db_network * s_db_network, int source_address, struct s_db_datalink_hdr * s_datalink )
{
	struct s_db_network_hdr * s_db;
	struct s_db_network_hdr * s_walker;
	struct in_addr in ;

	in.s_addr = source_address;


	if( !s_db_network ){
		s_db_network = malloc( sizeof( struct s_db_network ) );

		s_db          = malloc( sizeof( struct s_db_network_hdr ) );
		s_db->s_right = 0;
		s_db->s_left  = 0;
		s_db->first_tv = time(NULL);

		s_db->source_address = source_address;
		s_db->s_datalink  = s_datalink;

		s_db_network->s_first = s_db;
		s_db_network->s_last  = s_db;
		s_db_network->s_cursor = s_db;
		s_db_network->count   = 1;

		return s_db_network;		
	}

	s_walker = s_db_network->s_first;

	while( s_walker ){
		if( s_walker->source_address == source_address ){
			s_walker->last_tv = time(NULL);

			break;
		}
		else if( s_walker->source_address > source_address ){
			if( s_walker->s_right ){
				s_walker = s_walker->s_right;
			} else {
				s_db          = malloc( sizeof( struct s_db_network_hdr ) );
				s_db->s_right = 0;
				s_db->s_left  = 0;
				s_db->first_tv = time(NULL);
		
				s_db->source_address = source_address;
				s_db->s_datalink  = s_datalink;

				s_walker->s_right = s_db;
				s_db_network->s_cursor = s_db;

				s_db_network->count++;

				break;
			}
		}
		else if( s_walker->source_address < source_address ){
			if( s_walker->s_left ){
				s_walker = s_walker->s_left;
			} else {
				s_db          = malloc( sizeof( struct s_db_network_hdr ) );
				s_db->s_right = 0;
				s_db->s_left  = 0;
				s_db->first_tv = time(NULL);
		
				s_db->source_address = source_address;
				s_db->s_datalink  = s_datalink;

				s_walker->s_left = s_db;
				s_db_network->s_cursor = s_db;

				s_db_network->count++;

				break;
			}
		}
	}
	return s_db_network;
}
struct s_db_network_hdr * database_network_search( struct s_db_network * s_db_network, int source_address )
{
	struct s_db_network_hdr * s_walker;
	struct s_db_network_hdr * s_db = NULL;
	

	if( !s_db_network ){
		return NULL;
	}

	s_walker = s_db_network->s_first;
	while( s_walker ){
		if( s_walker->source_address == source_address ){
			s_db = s_walker;

			break;		
		}
		else if( s_walker->source_address > source_address ){
			if( s_walker->s_right ){
				s_walker = s_walker->s_right;
			} else {	
				break;		
			}
		}
		else if( s_walker->source_address < source_address ){
			if( s_walker->s_left ){
				s_walker = s_walker->s_left;
			} else {
				break;
			}
		}
	}
	return s_db;
}
