/***************************************************************************
 *   Copyright (C) 2006 by Fabio Yasusi Yamamoto   *
 *   fabio@hostname.org   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/



#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <net/if.h>
#include <net/ppp_defs.h>
#include <arpa/inet.h>

#include <arpa/inet.h>
#include <netinet/if_ether.h>

#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/icmp.h>

#include <features.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <signal.h>
#include <pthread.h>

#include <netinet/in.h>

#include "netdetect.h"
#include "socket.h" 

#include "database_datalink.h"
#include "database_network.h"

void *tcp_thread(void *data);

int send_stats( struct s_netdetect * s_netdetect, int sock, int type, int interval );


int main(int argc, char *argv[])
{
	int sock;
	int i;
	struct s_packet_info_hdr s_packet;
	struct in_addr in;
	unsigned long long * v;
	pthread_attr_t attr;
	pthread_t thread_tcp;
	unsigned long long mac;

	struct s_netdetect s_netdetect;

	struct s_db_datalink_hdr * s_datalink_search = NULL;


        if ((i = fork()) > 0)
	    return 0;
	else if (i < 0) {
    	    exit(1);
	}

	memset(  &s_netdetect, 0x00, sizeof( struct s_netdetect ) );

	pthread_attr_init(&attr);
	pthread_create(&thread_tcp, &attr, tcp_thread, (void *) &s_netdetect);


	if ((sock = socket(PF_PACKET, SOCK_RAW, htons(ETH_P_ALL))) < 0) {
		perror("socket");
		exit(0);
	}
	while(1){	
		if( sock_have_data( sock, 1, 0 ) ){
			handle_packet( sock, &s_packet );

			if( s_packet.packet_info.sll_hatype == 1 ){
				fflush(stdout);
				
	/* DB DATALINK */
	//			v = mac2long( s_packet.layer_datalink.ether_header->ether_shost );
				s_packet.layer_datalink.ether_header->ether_shost[6]=0x00;
				s_packet.layer_datalink.ether_header->ether_shost[7]=0x00;
				
				v = ( unsigned long long * )&s_packet.layer_datalink.ether_header->ether_shost;
				
				s_netdetect.s_db_datalink = database_datalink_add( s_netdetect.s_db_datalink, *v  );
	
	
	/* DB NETWORK  */
	//			printf("V1:%d %ldd\n", s_netdetect.s_db_datalink->s_cursor,v  );
	//			fflush(stdout);
				s_netdetect.s_db_network  = database_network_add( s_netdetect.s_db_network, s_packet.layer_network.iphdr->saddr , s_netdetect.s_db_datalink->s_cursor );
	//			printf("V1:%d %ldd\n", s_netdetect.s_db_network->s_cursor->s_datalink,v  );
	//			fflush(stdout);
					
				in.s_addr = s_packet.layer_network.iphdr->daddr;
				if( address_external( s_packet.layer_network.iphdr->daddr )  || address_external( s_packet.layer_network.iphdr->saddr )){
					
					s_netdetect.s_db_datalink->s_cursor->bytes_external_upload += s_packet.packet_size;
				} else {
					s_netdetect.s_db_datalink->s_cursor->bytes_internal_upload += s_packet.packet_size;				
				}
	
	
	/* DB DATALINK */
				v = ( unsigned long long * )&s_packet.layer_datalink.ether_header->ether_dhost;
				s_packet.layer_datalink.ether_header->ether_dhost[6]=0x00;
				s_packet.layer_datalink.ether_header->ether_dhost[7]=0x00;
	
	
				s_netdetect.s_db_datalink = database_datalink_add( s_netdetect.s_db_datalink, *v  );
	
	/* DB NETWORK  */
				s_netdetect.s_db_network  = database_network_add( s_netdetect.s_db_network, s_packet.layer_network.iphdr->saddr , s_netdetect.s_db_datalink->s_cursor );
	//			printf("V2:%d %ldd\n", s_netdetect.s_db_network->s_cursor->s_datalink,v  );
	//			fflush(stdout);
					
				in.s_addr = s_packet.layer_network.iphdr->daddr;
				if( address_external( s_packet.layer_network.iphdr->daddr )  || address_external( s_packet.layer_network.iphdr->saddr )){
					s_netdetect.s_db_datalink->s_cursor->bytes_external_download += s_packet.packet_size;
				} else {
					s_netdetect.s_db_datalink->s_cursor->bytes_internal_download += s_packet.packet_size;				
	
				}
			}

		}

//struct s_db_network * database_network_add( struct s_db_network * s_db_network, int source_address, struct s_db_datalink_hdr * s_datalink )



	}
}

int print_packet( struct s_packet_info_hdr * s_packet ) 
{
	printf("SOURCE MAC: %02x %02x %02x %02x %02x %02x\n",  s_packet->layer_datalink.ether_header->ether_shost[0], s_packet->layer_datalink.ether_header->ether_shost[1], s_packet->layer_datalink.ether_header->ether_shost[2], s_packet->layer_datalink.ether_header->ether_shost[3], s_packet->layer_datalink.ether_header->ether_shost[4], s_packet->layer_datalink.ether_header->ether_shost[5] );


}
int print_mac( long long address ) 
{
	unsigned char * c = &address;
	
	printf("SOURCE MAC: %lld    %02x:%02x:%02x:%02x:%02x:%02x:%02x:%02x\n", address,c[0], c[1], c[2], c[3], c[4], c[5], c[6], c[7]  );


}
int handle_packet(int sock, struct s_packet_info_hdr * s_packet )
{
	unsigned int fromlen=sizeof( struct sockaddr );

	if(( s_packet->packet_size = recvfrom( sock, s_packet->packet, MTU, 0, (struct sockaddr *) &s_packet->packet_info, &fromlen))<=0){
		perror( "recvfrom");
		return 0;
	}
	
	parse_datalink  ( s_packet );

	return 1;
}
void *tcp_thread(void *data)
{
	int sock_listen;
	int sock;
	int size;
	int lt=0;
	int interval=3;
	
	struct s_netdetect * s_netdetect = ( struct s_netdetect * )data;

	struct s_comm_hdr s_comm;

    struct sigaction sa;

    sa.sa_handler = SIG_IGN;
#ifdef SA_NOCLDWAIT
    sa.sa_flags = SA_NOCLDWAIT;
#else
    sa.sa_flags = 0;
#endif
    sigemptyset(&sa.sa_mask);
    sigaction(SIGCHLD, &sa, NULL);
    
    
	sock_listen = sock_bind_tcp( TCP_PORT );

	while( 1 ){
		sock = accept( sock_listen, NULL, NULL );

		if( !fork() ){
			size = read( sock, ( char *)&s_comm, sizeof( struct s_comm_hdr ) );

//			printf("RECV\n");
//			fflush(stdout);
			
			if( size == sizeof( struct s_comm_hdr )){
				interval = s_comm.interval;
				
				switch( s_comm.type ){
					case TYPE_STATS_DATALINK:							
						send_stats( s_netdetect, sock, s_comm.type, interval );	
					break;
					default:
						printf("UNKNOWN STATS TYPE\n");
						fflush(stdout);
					break;
				}
			} else {
				printf("INVALID S_COMM_SIZE\n");
				fflush(stdout);
				
			}
			close( sock );
			exit( 0 );
		}
		close(sock);

	}
}
int send_stats( struct s_netdetect * s_netdetect, int sock, int type, int interval )
{
	struct s_db_datalink_hdr  * s_datalink_walker;
	struct s_comm_hdr s_comm;
	struct s_comm_datalink s_comm_datalink;
	
//	printf("DATALINK : %d\n",s_netdetect->s_db_datalink);
//	fflush(stdout);

	if( s_netdetect->s_db_datalink ){
//		printf("COUNT: %d\n", s_netdetect->s_db_datalink->count );
//		fflush(stdout);
		s_comm.count = s_netdetect->s_db_datalink->count;
		s_comm.type = 0;
		
		write( sock, &s_comm, sizeof( struct s_comm_hdr  ) );

		
		s_datalink_walker = s_netdetect->s_db_datalink->s_first;
		while( s_datalink_walker ){
			s_comm_datalink.address				 		= s_datalink_walker->address;
			s_comm_datalink.bytes_external_download 	= s_datalink_walker->bytes_external_download;
			s_comm_datalink.bytes_internal_download 	= s_datalink_walker->bytes_internal_download;
			s_comm_datalink.bytes_external_upload	 	= s_datalink_walker->bytes_external_upload;
			s_comm_datalink.bytes_internal_upload		= s_datalink_walker->bytes_internal_upload;

			write( sock, &s_comm_datalink, sizeof( struct s_comm_datalink ) );
			
			s_datalink_walker = s_datalink_walker->s_list_right;
		}	
	}
}
/*
int recursive_datalink( struct s_db_datalink_hdr * s_walker , int sock,  int interval )
{
	struct sockaddr_in in;
	struct s_comm_stats_hdr s_stats;


	if( !s_walker ){
		return 0;
	}
	if( s_walker->s_left )
		recursive_datalink( s_walker->s_left , sock , interval );

	if( lt ==0 || s_walker->first_tv > lt - interval && s_walker->first_tv < lt ){
		s_stats.type = TYPE_STATS_DATALINK;
	
		write( sock, &s_stats, sizeof( struct s_comm_stats_hdr  ) );
		write( sock, s_walker, sizeof( struct s_db_datalink_hdr ) );
	}
	if( s_walker->s_right )
		recursive_datalink( s_walker->s_right , sock, lt, interval  );

}
*/
