#define TCP_PORT 9933
#define MTU 1500

#define TYPE_STATS_DATALINK 0x01
#define TYPE_STATS_BYTES 0x02

struct s_packet_info_hdr {
	char packet[MTU];
	int  packet_size;

	struct sockaddr_ll packet_info;

	union layer_datalink {
		 struct ether_header * ether_header;
	} layer_datalink;
	int layer_datalink_size;

	union layer_network {
		 char * pointer;

		 struct iphdr * iphdr;
		 struct arp_packet * arp_packet;
	} layer_network;
	int layer_network_size;


};
struct s_netdetect {
	struct s_db_datalink * s_db_datalink;
	struct s_db_network  * s_db_network;
};
struct s_comm_hdr {
	char type;
	int count;
	int interval;
};
struct s_comm_stats_hdr {
	char type;
};
struct s_comm_datalink {
	unsigned long long address;
	unsigned long long bytes_external_download;
	unsigned long long bytes_internal_download;
	unsigned long long bytes_external_upload;
	unsigned long long bytes_internal_upload;
};

int handle_packet(int sock, struct s_packet_info_hdr * s_packet );

