
#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <net/if.h>
#include <net/ppp_defs.h>
#include <arpa/inet.h>

#include <arpa/inet.h>
#include <netinet/if_ether.h>

#include <linux/ip.h>
#include <linux/tcp.h>
#include <linux/udp.h>
#include <linux/icmp.h>

#include <features.h>
#include <netpacket/packet.h>
#include <net/ethernet.h>
#include <net/if_arp.h>
#include <signal.h>

int address_netmask( unsigned long address, unsigned long i_network, char i_netmask );

int sock_have_data(int socket, int s, int m)
{
    fd_set fds;
    struct timeval tv;

    FD_ZERO(&fds);
    FD_SET(socket, &fds);

    tv.tv_sec = s;
    tv.tv_usec = m;

    select(socket + 1, &fds, NULL, NULL, &tv);
    if (FD_ISSET(socket, &fds)) {
        return 1;
    }
    return 0;
}

int sock_bind_tcp(int port)
{
    int STCP;
    int reuse = 1;
    struct sockaddr_in saddr;
    if ((STCP = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP)) < 0) {
        perror("socket");
        exit(0);
    }
    if (setsockopt(STCP, SOL_SOCKET, SO_REUSEADDR, &reuse, sizeof(reuse)) < 0) {
        perror("setsockopt");
        exit(1);
    }

    saddr.sin_addr.s_addr = inet_addr("0.0.0.0");
    saddr.sin_family = AF_INET;
    saddr.sin_port = htons(port);

    if (bind(STCP, (struct sockaddr *) &saddr, sizeof(struct sockaddr)) < 0) {
        perror("bind");
        exit(0);
    }
    listen(STCP, -1);
    return STCP;
}

int address_external( unsigned long address )
{
	if( address_netmask ( address, inet_addr("10.0.0.0"),8 ) ){
		return 0;	
	}
	if( address_netmask ( address, inet_addr("172.16.0.0"),16 ) ){
		return 0;	
	}
	if( address_netmask ( address, inet_addr("192.168.0.0"),16 ) ){
		return 0;	
	}
	
	return 1;
}
int address_netmask( unsigned long address, unsigned long i_network, char i_netmask )
{
 	unsigned long init;
 	unsigned long end;
                                                                                                                                                                                                    
    init = i_network & ( unsigned long )(( 1<<i_netmask) -1 );                                                                                                                                
    end  = i_network | ( unsigned long )( 0- (1<<i_netmask));               
    
    if( ntohl( address ) >= ntohl( init ) && ntohl( address ) <= ntohl( end )){                                                                                                                     
		return 1;
    }     
	return 0;
	
}
