#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/socket.h>
#include <sys/time.h>
#include <sys/errno.h>
#include <byteswap.h>
#include <fcntl.h>
#include <list.h>
#include <time.h>
#include <sys/stat.h>
#include <sys/types.h>
#include "database_datalink.h"

#include <sqlite3.h>
#include "socket.h"

#define TCP_PORT 9933

#define TYPE_STATS_DATALINK 0x01
#define TYPE_STATS_BYTES 0x02

int file_stats( char * group );
int stats( int external,char * group );

struct s_comm_hdr {
	char type;
	int count;
	int interval;
};
struct s_comm_stats_hdr {
	char type;
};
struct s_comm_datalink {
	unsigned long long address;
	unsigned long long bytes_external_download;
	unsigned long long bytes_internal_download;
	unsigned long long bytes_external_upload;
	unsigned long long bytes_internal_upload;
};

struct s_client_hdr {
	unsigned long tv;
	unsigned long long address;
	unsigned long long bytes_external_download;
	unsigned long long bytes_internal_download;
	unsigned long long bytes_external_upload;
	unsigned long long bytes_internal_upload;
};
struct s_group_hdr {
	char name[255];
	struct s_list * s_mac_list;	
};
struct s_collector_hdr {
//	struct s_list * s_group_list;	
	struct s_list * s_mac_list;	

};


struct s_client_hdr * search_client( struct s_collector_hdr * s_collector, unsigned long long address );


int db_begin( sqlite3 * db )
{
    int rc;
    char *errmsg = 0;
	
    char query[255];
    
		

    snprintf(query, 255, "BEGIN;");
	
    rc = sqlite3_exec(db, query, 0, 0, &errmsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", errmsg);
    }
	
	return 1;	
}
int db_end( sqlite3 * db )
{
    int rc;
    char *errmsg = 0;
	
    char query[255];
    
		

    snprintf(query, 255, "END;");
	
    rc = sqlite3_exec(db, query, 0, 0, &errmsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", errmsg);
    }
	
	return 1;	
}


int select_groupname_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_collector_hdr *s_db = (struct s_collector_hdr *) p_data;
	struct s_client_hdr s_client;

	memset( &s_client, 0x00, sizeof( struct s_client_hdr ) );
		
	s_client.address = atoll(p_fields[0]);

	s_db->s_mac_list = list_add( s_db->s_mac_list, ( char *)&s_client, sizeof( struct s_client_hdr )  );


    return 0;
}
/*
int select_group_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_collector_hdr *s_db = (struct s_collector_hdr *) p_data;
    struct s_group_hdr s_group;

	snprintf( s_group.name, 64, "%s", p_fields[0] );  

	s_db->s_group_list = cert.list.add( s_db->s_group_list, s_group.name, sizeof( struct s_collector_hdr)  );

    return 0;
}
*/
int db_get_clients_by_groupname( struct s_collector_hdr * s_collector, char * name )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;
    char query[255];    	
    
    
    	 
    rc = sqlite3_open("/var/NatACL/NatACL.v1.db", &db);

    snprintf(query, 255, "select address.mac_address from bu_group, address  where address.bu_group_id=bu_group.id and  bu_group.name='%s'", name );
	
    rc = sqlite3_exec(db, query, select_groupname_callback, s_collector, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);
	
	return 1;
}
/*
int db_get_groups( struct s_collector_hdr * s_collector )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;
    char query[255];    	
    
    struct s
    	 
    rc = sqlite3_open("dhcp.db", &db);

    snprintf(query, 255, "select name from  bu_group" );
	
    rc = sqlite3_exec(db, query, select_group_list_callback, s_collector, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);
	
	return 1;
}
*/
	

int main( int argc, char ** argv )
{
	int external=0;
	if( argc<3 ){
		printf("Usage: 	<file_stats> <group_name>\n");
		printf("	<stats>      <internal/external> <group_name>\n");
		exit  ( 0 );			
	}
	

	

	if( strcmp( argv[1], "file_stats" ) == 0 ){
		file_stats( argv[2] );		
	}
	if( strcmp( argv[1], "stats" ) == 0 ){
	if( strcmp( argv[2],"external" ) == 0 ){
		external=1;
	} else 	if( strcmp( argv[2],"internal" ) == 0 ){
		external=0;
	} else {
		printf("Incorrect parameter\n");
		fflush(stdout);
		exit( 0 );
	}

		stats( external, argv[3] );		
	}
	return 1;
}
char * gen_log_filename( char * group )
{
  	static		char buffer[255];
  	
//    char        temp01[512];                                                    
    char        tmp[255];                                                       
//    struct timeval tv;                                                          
                                                                                
    struct      tm      *tm;                                                    
    time_t      t;                                                              
//    va_list     args; 

    time        ( &t );                                                         
                                                                                
    tm = localtime(&t);                                                         
                                                                                
    strftime(tmp, 255, "%Y%m%d", tm );                             
                                                                                
    snprintf( buffer,255, "/var/NatACL/stats/%s/%s.stat",tmp, group  );                                        
		
	return buffer;
}
char * gen_log_directory( )
{
  	static		char buffer[255];
  	
//    char        temp01[512];                                                    
    char        tmp[255];                                                       
//    struct timeval tv;                                                          
                                                                                
    struct      tm      *tm;                                                    
    time_t      t;                                                              
//    va_list     args; 

    time        ( &t );                                                         
                                                                                
    tm = localtime(&t);                                                         
                                                                                
    strftime(tmp, 255, "%Y%m%d", tm );                             
                                                                                
    snprintf( buffer,255, "/var/NatACL/stats/%s",tmp );                                        
		
	return buffer;
}
int file_stats( char * group )
{	
	int i;
	int s;
	int sock;
//    int rc;
//	int ret;
	struct s_comm_hdr s_comm;
	struct s_comm_datalink s_comm_datalink;
//	struct s_db_datalink 	* s_db_datalink = NULL;
	struct s_collector_hdr s_collector;
//	struct s_group_hdr 		* s_group;
//	struct s_list_hdr 		* s_walker;
	struct s_client_hdr 	* s_client;
	sqlite3 *db=NULL;

//	long long total_external_upload=0;
//	long long total_external_download=0;
	int fd=0;
	
	s_collector.s_mac_list = NULL;

	db_get_clients_by_groupname( &s_collector, group);

	sock = 	sock_connect_tcp( "127.0.0.1", TCP_PORT, 10 );
		
	if( sock<=0 ){
		perror("connect");
		exit  ( 0 );	
	}	
		
	s_comm.count 	= 0;
	s_comm.interval = 0;
	s_comm.type 	= TYPE_STATS_DATALINK;

	write( sock, &s_comm, sizeof( struct s_comm_hdr ) );	
	read ( sock, &s_comm, sizeof( struct s_comm_hdr ) );

	mkdir( gen_log_directory(), 0777 );
	
	if(( fd = open( gen_log_filename( group ), O_RDWR | O_APPEND | O_CREAT, 0777 ))==-1){
		perror("open");
		exit  ( 0 );	
	}
	
	for( i=0;i<s_comm.count;i++){
			s = read ( sock, &s_comm_datalink, sizeof( struct s_comm_datalink ) );

			if( s == sizeof( struct s_comm_datalink ) ){
				if( s_comm_datalink.address != -1 && s_comm_datalink.address ){
						s_client = search_client( &s_collector, s_comm_datalink.address );
						if( s_client ){
							s_client->tv = time(NULL);
							s_client->bytes_external_download = s_comm_datalink.bytes_external_download;
							s_client->bytes_internal_download = s_comm_datalink.bytes_internal_download;
							s_client->bytes_external_upload = s_comm_datalink.bytes_external_upload;
							s_client->bytes_internal_upload = s_comm_datalink.bytes_internal_upload;
													
							write( fd, s_client, sizeof( struct s_client_hdr ));
						} 
				}	
			} else {
				exit( 0 );	
			}	
	}
	close( sock );

    sqlite3_close(db);
    close( fd );

    return 1;
}

int stats( int external, char * group )
{	
	int i;
	int s;
	int sock;
	struct s_comm_hdr s_comm;
	struct s_comm_datalink s_comm_datalink;
//	struct s_db_datalink * s_db_datalink = NULL;
	struct s_collector_hdr s_collector;
	struct s_client_hdr * s_client;
	sqlite3 *db = NULL;

	long long total_external_upload=0;
	long long total_external_download=0;
	long long total_internal_upload=0;
	long long total_internal_download=0;
	
	s_collector.s_mac_list = NULL;



	db_get_clients_by_groupname( &s_collector, group);

	sock = 	sock_connect_tcp( "127.0.0.1", TCP_PORT, 10 );
		
	if( sock<=0 ){
		perror("connect");
		exit  ( 0 );	
	}	
		
	s_comm.count 	= 0;
	s_comm.interval = 0;
	s_comm.type 	= TYPE_STATS_DATALINK;

	write( sock, &s_comm, sizeof( struct s_comm_hdr ) );	
	read ( sock, &s_comm, sizeof( struct s_comm_hdr ) );

	for( i=0;i<s_comm.count;i++){
			s = read ( sock, &s_comm_datalink, sizeof( struct s_comm_datalink ) );

			if( s == sizeof( struct s_comm_datalink ) ){
				if( s_comm_datalink.address != -1 && s_comm_datalink.address ){
						s_client = search_client( &s_collector, s_comm_datalink.address );
						if( s_client ){
							s_client->bytes_external_download = s_comm_datalink.bytes_external_download;
							s_client->bytes_internal_download = s_comm_datalink.bytes_internal_download;
							s_client->bytes_external_upload = s_comm_datalink.bytes_external_upload;
							s_client->bytes_internal_upload = s_comm_datalink.bytes_internal_upload;
						
							total_external_download +=s_comm_datalink.bytes_external_download;
							total_external_upload   +=s_comm_datalink.bytes_external_upload;
							total_internal_download +=s_comm_datalink.bytes_internal_download;
							total_internal_upload   +=s_comm_datalink.bytes_internal_upload;
						} 
				}	
			} else {
				exit( 0 );	
			}	
	}
	if( external ){
		printf("%lld\n", total_external_download );
		printf("%lld\n", total_external_upload );	
	} else {
		printf("%lld\n", total_internal_download );
		printf("%lld\n", total_internal_upload );
	}
	close( sock );
//	db_end( db );

    sqlite3_close(db);
    return 1;
}
struct s_client_hdr * search_client( struct s_collector_hdr * s_collector, unsigned long long address )
{
	struct s_list_hdr * s_walker=NULL;
//	struct s_client_hdr * s_client;
	
	s_walker = s_collector->s_mac_list->s_first;
	while( s_walker ){
//		printf("%lld %lld\n", address,(( struct s_client_hdr *)s_walker->data)->address );
//		fflush(stdout);

		if( (( struct s_client_hdr *)s_walker->data)->address == address ){
			return ( struct s_client_hdr *)s_walker->data;	
		}
		s_walker = s_walker->s_right;	
	}	
	return NULL;
}
