#include <stdio.h>
#include <string.h>
#include <unistd.h>

#include <sqlite3.h>
//#include <libcert.h>

#include "db.h"

int select_group_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;

    struct s_group_hdr s_group;

    s_group.id = atol(p_fields[0]);
    snprintf( s_group.name, 64, "%s", p_fields[1]);


	s_db->s_groups = cert.list.add( s_db->s_groups, &s_group, sizeof( struct s_group_hdr ));

    return 0;
}
int select_client_list_callback(void *p_data, int num_fields, char **p_fields, char **p_col_names)
{
    struct s_db_hdr *s_db = (struct s_db_hdr *) p_data;


    struct s_clientdb_hdr s_clientdb;

    s_clientdb.mac = atoll(p_fields[0]);
    s_clientdb.address = atol(p_fields[1]);
    snprintf( s_clientdb.name, 128, "%s", p_fields[2]);


	s_db->s_clientdbs = cert.list.add( s_db->s_clientdbs, &s_clientdb, sizeof( struct s_clientdb_hdr ));

    return 0;
}

int db_list_group( struct s_db_hdr * s_db  )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];
    
	
    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select id, name from bu_group");
	
    rc = sqlite3_exec(db, query, select_group_list_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);
	
	return 1;
}
int db_list_mac_by_group( struct s_db_hdr * s_db, char * group  )
{
    sqlite3 *db;
    char *zErrMsg = 0;
    int rc;

    char query[255];
    
	
    rc = sqlite3_open("/var/dhcp.db", &db);

    snprintf(query, 255, "select address.mac_address, address.client_address, address.name from address, bu_group where address.bu_group_id = bu_group.id and bu_group.name='%s'",group);
	
    rc = sqlite3_exec(db, query, select_client_list_callback, s_db, &zErrMsg);
    if (rc != SQLITE_OK) {
        fprintf(stderr, "SQL error: %s\n", zErrMsg);
    }
    sqlite3_close(db);
	
	return 1;
}
		
		
